#!/bin/sh
set -e

# $Id: autogen.sh 2735 2022-09-17 21:53:56Z teshields $

# This file is part of the Libnew package that provides replacement
# implementations for core standard C library memory management
# functions, and for the standard C++ 'new()' and 'delete()' operators.
#
# Copyright (C) 2022  Thomas E. Shields
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# This script (re)creates './libnew/configure', './libnew/aclocal.m4',
# './libnew/config.h.in', './libnew/Makefile.in', etc., missing from the
# distributed './libnew' directory.
#
# Make sure that you have Autoconf, Automake and Libtool installed on your
# system, and that the corresponding *.m4 files are visible to Aclocal.

autoreconf --install

echo
echo "Now run './configure'."
