%{
#if defined (__cplusplus)
#include <cstdio>
#else
#include <stdio.h>
#endif

#if YYBTYACC && !YYBYACC
/* the `btyacc' 3.0 skeleton omits the following */
#include "gram.h"
#endif

extern int yylex(void);

#if YYBTYACC && !YYBYACC
void yyerror(const char *, ...);
#else
void yyerror(const char *);
#endif
%}

%token ICONST 
%left '+' '-'
%left '*' '/'

%%
expr    :       expr    '*'     expr
        |       expr    '/'     expr
        |       expr    '+'     expr
        |       expr    '-'     expr
        |       '('     expr    ')'
        |       ICONST
        ;
%% 
#if YYBTYACC && !YYBYACC
void yyerror(const char *s, ...)
{extern int yylineno;
 fprintf(stderr,"Near line %d: %s\n",yylineno,s); 
}  
#else  
void yyerror(const char *s) {fprintf(stderr,"%s\n",s);}
#endif

#ifndef YYMSTA
int yyparse(void);
#endif
int main() 
  {return(yyparse()); 
  } 
