%{
#if defined (__cplusplus)
#include <cstdio>
#else
#include <stdio.h>
#endif

#if YYBTYACC && !YYBYACC
/* the `btyacc' 3.0 skeleton omits the following */
#include "parser.h"
#endif

extern int yylex(void);

#if YYBTYACC && !YYBYACC
void yyerror(const char *, ...);
#else
void yyerror(const char *);
#endif
%}

%token ICONST 
%left '+' '-'
%left '*' '/'

@attributes {char *string; } ICONST
@attributes {long val;}      expr 

%%
expr    :       expr    '*'     expr 
                @{ @i @expr.0.val@ = @expr.1.val@ * @expr.2.val@;  @} 

        |       expr    '/'     expr
                @{ @i @expr.0.val@ = @expr.1.val@ / @expr.2.val@;  @} 

        |       expr    '+'     expr
                @{ @i @expr.val@ = @expr.1.val@ + @expr.2.val@;    @} 

        |       expr    '-'     expr
                @{ @i @expr.0.val@ = @expr.1.val@ - @expr.2.val@;  @} 

        |       '('     expr    ')'
                @{ @i @expr.0.val@ = @expr.1.val@;                 @} 

        |       ICONST
                @{ @i @expr.val@ = atoi(@ICONST.string@);          @} 
        ;
%% 
#if YYBTYACC && !YYBYACC
void yyerror(const char *s, ...)
{extern int yylineno;
 fprintf(stderr,"Near line %d: %s\n",yylineno,s); 
 yyyabort(); 
}  
#else  
void yyerror(const char *s)
{fprintf(stderr,"%s\n",s);
 yyyabort(); 
}
#endif

#ifndef YYMSTA
int yyparse(void);
#endif
int main() 
  {return(yyparse()); 
  } 
