/* $Id: code.h 2379 2022-01-07 22:41:51Z teshields $ */ 
  
/* This file is part of Ox, an Attribute Grammar Compiling System
   that augments the specification functionality of Lex and Yacc, and
   input specification compatible lexer and parser generators.

   Copyright (C) 1992-1993  Kurt M. Bischoff
   Copyright (C) 2016-2022  Thomas E. Shields
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

#if defined (__cplusplus)
#include <cstdio>
#else
#include <stdio.h>
#endif

extern FILE *tempOut; 
#define tempOutID "g.c" 

extern long stgSize(enum symType,long); 
extern labelType newLabelNum(void); 
extern labelType newReturnLabelNum(void); 
extern void cgHeader(void); 
extern void cgTrailer(void); 
extern void cgFuncCall(struct env *,
		       struct sym *,
		       regNumType,
		       enum pred,
		       lineNumType); 
extern void cgBlockEnter(struct env *); 
extern void cgBlockExit(struct env *); 
extern void cgFuncAddress(struct sym *); 
extern void cgFuncTrailer(struct sym *); 
extern void cgBinArithExpr(int,int,enum symType);
extern void cgRelExpr(int,int,enum symType);
extern void cgBinLogExpr(int,int);
extern void cgUnrArithExpr(int,int,enum symType);
extern void cgLogNegExpr(int);
extern void cgEmptyIndexSeq(struct env *,
			    struct sym *,
			    lineNumType,
			    int,
			    struct dim *);
extern void cgIndexSeq(struct sym *,int,struct dim *);
extern void cgConstSimpleExpr(int,enum symType,union num);
extern void cgEOF(int);
extern void cgAssign(int,enum symType); 
extern void cgPush(int); 
extern void cgCondDeref(struct sym *,int,enum symType); 
extern void cgCast(int,enum symType,enum symType);
extern void cgOutputNoArg(char *,regNumType);
extern void cgOutputOneArg(char *,int,enum symType);
extern void cgInput(char *,int,enum symType,lineNumType); 
extern void cgIfThen(enum symType,lineNumType,labelType); 
extern void cgIfThenElse(enum symType,lineNumType,labelType); 
extern void cgThen(int,labelType); 
extern void cgElse(labelType); 
extern void cgWdecision(int,labelType); 
extern void cgWhileStatement(enum symType,lineNumType,labelType); 
extern void cgWhile(labelType); 
extern void cgReturnStmt(struct env *,regNumType,enum symType,lineNumType);
extern void cgExitStmt(regNumType,enum symType,lineNumType);
