#line 1 "flex/agc-strip-lexer.cc"
#include <fstream>

#include "agc-Lfile.hh"
#include "messages.hh"
#include "opts.hh"
#include "outMgr.hh"
#include "scan.hh"

#define YY_DECL \
  int AGC::STRIP::Lexer::yylex (AGC::lexer::value_type& yylval \
                                    __attribute__ ((unused)), \
                                AGC::location& yylloc)

// inhibit the 'flex' builtin definition of 'struct yy_buffer_state'
#define YY_STRUCT_YY_BUFFER_STATE

#line 18 "flex/agc-strip-lexer.cc"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

/* %not-for-header */
/* %if-c-only */
/* %if-not-reentrant */
/* %endif */
/* %endif */
/* %ok-for-header */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 6
#define YY_FLEX_SUBMINOR_VERSION 4
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* %if-c++-only */
    /* The c++ scanner is a mess. The FlexLexer.h header file relies on the
     * following macro. This is required in order to pass the c++-multiple-scanners
     * test in the regression suite. We get reports that it breaks inheritance.
     * We will address this in a future release of flex, or omit the C++ scanner
     * altogether.
     */
    #define yyFlexLexer strip_FlexLexer
/* %endif */

/* %if-c-only */
/* %endif */

#ifdef yyalloc
#define strip_alloc_ALREADY_DEFINED
#else
#define yyalloc strip_alloc
#endif

#ifdef yyrealloc
#define strip_realloc_ALREADY_DEFINED
#else
#define yyrealloc strip_realloc
#endif

#ifdef yyfree
#define strip_free_ALREADY_DEFINED
#else
#define yyfree strip_free
#endif

/* %if-c-only */
/* %endif */

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
/* %if-c-only */
/* %endif */

/* %if-tables-serialization */
/* %endif */
/* end standard C headers. */

/* %if-c-or-c++ */
/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#ifndef SIZE_MAX
#define SIZE_MAX               (~(size_t)0)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

/* %endif */

/* begin standard C++ headers. */
/* %if-c++-only */
#include <iostream>
#include <errno.h>
#include <cstdlib>
#include <cstdio>
#include <cstring>
/* end standard C++ headers. */
/* %endif */

/* TODO: this is always defined, so inline it */
#define yyconst const

#if defined(__GNUC__) && __GNUC__ >= 3
#define yynoreturn __attribute__((__noreturn__))
#else
#define yynoreturn
#endif

/* %not-for-header */
/* Returned upon end-of-file. */
#define YY_NULL 0
/* %ok-for-header */

/* %not-for-header */
/* Promotes a possibly negative, possibly signed char to an
 *   integer in range [0..255] for use as an array index.
 */
#define YY_SC_TO_UI(c) ((YY_CHAR) (c))
/* %ok-for-header */

/* %if-reentrant */
/* %endif */

/* %if-not-reentrant */

/* %endif */

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *
/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START
/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)
/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin  )
#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

/* %if-not-reentrant */
extern int yyleng;
/* %endif */

/* %if-c-only */
/* %if-not-reentrant */
/* %endif */
/* %endif */

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2
    
    #define YY_LESS_LINENO(n)
    #define YY_LINENO_REWIND_TO(ptr)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )
#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
/* %if-c-only */
/* %endif */

/* %if-c++-only */
	std::streambuf* yy_input_file;
/* %endif */

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	int yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* %if-c-only Standard (non-C++) definition */
/* %not-for-header */
/* %if-not-reentrant */
/* %endif */
/* %ok-for-header */

/* %endif */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)
/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* %if-c-only Standard (non-C++) definition */
/* %if-not-reentrant */
/* %not-for-header */
/* %ok-for-header */

/* %endif */
/* %endif */

void *yyalloc ( yy_size_t  );
void *yyrealloc ( void *, yy_size_t  );
void yyfree ( void *  );

#define yy_new_buffer yy_create_buffer
#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}
#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}
#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* %% [1.0] yytext/yyin/yyout/yy_state_type/yylineno etc. def's & init go here */
/* Begin user sect3 */
#define YY_SKIP_YYWRAP

#define FLEX_DEBUG
typedef flex_uint8_t YY_CHAR;

#define yytext_ptr yytext

#include <FlexLexer.h>

int yyFlexLexer::yywrap() { return 1; }

/* %% [1.5] DFA */

/* %if-c-only Standard (non-C++) definition */
/* %endif */

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
/* %% [2.0] code to fiddle yytext and yyleng for yymore() goes here \ */\
	yyleng = (int) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
/* %% [3.0] code to copy yytext_ptr to yytext[] goes here, if %array \ */\
	(yy_c_buf_p) = yy_cp;
/* %% [4.0] data tables for the DFA and the user's section 1 definitions go here */
#define YY_NUM_RULES 101
#define YY_END_OF_BUFFER 102
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static const flex_int16_t yy_accept[439] =
    {   0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  102,  101,    9,    2,    9,    9,    9,    9,
        9,   84,   83,   82,   84,   84,   83,   83,   83,   83,
       45,   45,   45,   45,   45,   58,   57,   66,   62,   62,
       66,   66,   74,   73,   68,   74,   74,   74,   74,   70,
       71,   50,   47,   50,   50,   50,   56,   52,   56,   56,
       56,   53,   54,   88,   87,   86,   88,   88,   87,   87,

       87,   87,   90,   91,   91,   93,   93,   93,   95,   96,
       94,   97,  100,   99,   98,  100,   14,   13,   11,   14,
       14,   14,   24,   23,   24,   24,   24,   22,   29,   27,
       28,   29,   29,   29,   27,   38,   36,   37,   38,   38,
       36,   20,   19,   16,   20,   20,   20,   80,   79,   76,
       80,   80,   80,    1,    0,    0,    0,    0,    6,    2,
        0,    0,    0,   83,    0,    0,   81,    0,   83,   83,
       83,   83,    0,   83,   82,    0,    0,    0,   41,    0,
        0,    0,    0,    0,   62,   65,    0,   62,    0,    0,
        0,    0,   61,    0,    0,    0,   67,    0,   69,   68,

        0,   46,    0,   47,    0,    0,    0,   51,    0,   52,
        0,   87,    0,    0,   85,    0,   87,   87,   87,   87,
        0,   87,   86,    0,   90,   89,   93,   92,   95,   95,
      100,  100,   10,    0,    0,   11,    0,    0,   21,    0,
        0,   27,    0,    0,    0,   27,   25,    0,   27,   36,
       30,    0,    0,    0,    0,    0,    0,   36,   15,    0,
       18,   17,   16,   75,    0,   78,   77,   76,    0,    8,
        0,    0,    0,    0,    0,    7,   83,    0,    0,    0,
       83,   83,   83,   83,   83,    0,    0,    0,   44,    0,
       42,    0,   39,    0,   64,    0,   59,    0,   60,    0,

       63,   72,    0,    0,    0,   72,    0,   49,    0,   48,
       55,    0,    0,    0,   55,   87,    0,    0,    0,   87,
       87,   87,   87,   87,    0,   14,    0,   24,    0,    0,
        0,   24,   27,    0,    0,    0,   26,    0,   31,    0,
        0,    0,    0,    0,    0,    0,   20,    0,   80,    0,
        0,    0,    0,    0,    0,   83,    0,   40,    0,    0,
        0,    0,    0,    0,   87,   12,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   35,    0,    0,    0,    4,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    5,    0,    0,   43,   34,
        0,    0,    0,    0,    0,    0,    0,    0,   32,    0,
        0,    0,    0,    3,    0,    0,   33,    0
    } ;

static const YY_CHAR yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        2,    2,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    1,    4,    1,    5,    6,    1,    7,    1,
        1,    8,    1,    1,    9,   10,   11,   12,   13,   13,
       13,   13,   13,   13,   13,   14,   14,    1,    1,    1,
        1,    1,    1,   15,   16,   16,   16,   16,   16,   16,
       17,   17,   17,   17,   17,   18,   17,   17,   17,   17,
       17,   17,   17,   17,   19,   17,   17,   20,   17,   17,
        1,   21,    1,    1,   22,    1,   23,   24,   25,   26,

       27,   28,   29,   30,   31,   17,   17,   32,   33,   34,
       35,   36,   17,   37,   38,   39,   40,   41,   42,   43,
       44,   17,   45,   46,   47,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static const YY_CHAR yy_meta[48] =
    {   0,
        1,    1,    2,    3,    1,    1,    4,    5,    6,    7,
        1,    8,    8,    8,    1,    9,   10,   10,   10,   10,
        3,   10,    9,    9,    9,    9,    9,    9,   10,   10,
       10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
       10,   10,   10,   10,    1,    1,    1
    } ;

static const flex_int16_t yy_base[509] =
    {   0,
        0,    0,    0,    1,   19,    0,    2,   65,    0,    7,
     1287,   66,   75,  120,  165,  210,   69,   77,   85,   94,
      257,    0,   66,   67,   91,   94,  104,  107,  112,  115,
      139,  141,  144,  168,  304,    0,  351,    0,  170,  186,
      191,  215, 1288, 1290, 1290, 1290,    6,  125, 1283,    0,
     1280, 1290, 1283, 1290, 1263,   98,  387,  396,    0,  110,
     1290,   65,  118,  147,  192, 1290, 1290, 1290,  190,  197,
      115,  126, 1290, 1290, 1290, 1262,  155, 1237,  180, 1290,
     1290, 1290, 1290,  212, 1277, 1233, 1290, 1290, 1258,  221,
      231, 1290, 1290, 1290, 1276, 1290, 1256,  231,  425,  434,

        0,  237,    0, 1290, 1265,    0, 1290, 1264,    0, 1290,
     1290,    0,    0, 1290, 1290,    0, 1290, 1290, 1290,  237,
     1247, 1269, 1290, 1290, 1251,  238, 1264, 1290, 1290, 1268,
     1290, 1248,  212,  239,    0, 1290, 1266, 1290,  243,  435,
        0, 1290, 1290, 1290,  245,  160, 1263, 1290, 1290, 1290,
      405,  357, 1262, 1290, 1262,   45, 1241, 1226, 1290, 1290,
      176, 1256, 1258, 1258, 1252,  411, 1290, 1253,  466,  469,
      393,  385,    0,    0, 1290, 1236, 1220, 1220, 1290, 1251,
      420, 1247, 1249, 1248,  418, 1290, 1247,  429, 1243,  447,
     1245, 1244, 1290, 1243, 1238,  479, 1290, 1239, 1290, 1290,

     1222, 1290, 1239, 1290, 1238, 1233,  482, 1290, 1234, 1290,
     1217, 1235, 1229,  490, 1290, 1230,  498,  522,  481,  424,
        0,    0, 1290, 1213,    0, 1290,    0, 1290,    0, 1290,
        0, 1290, 1290, 1228, 1198, 1290, 1224,  507, 1290, 1225,
     1208, 1226, 1220,  516,  230,    0, 1290, 1223,    0, 1223,
     1290, 1221, 1192, 1195,  414, 1190, 1197,    0, 1290, 1214,
     1290, 1290, 1290, 1290, 1213, 1290, 1290, 1290, 1214, 1290,
     1177, 1176, 1189, 1190, 1209, 1290, 1290,  519, 1204, 1205,
     1204,  121, 1290,  441,  524, 1169, 1171, 1203, 1290, 1202,
     1290, 1201, 1290, 1200, 1290, 1199, 1290, 1186, 1290, 1185,

     1290, 1290,  532, 1180, 1178, 1177, 1178, 1290, 1174, 1290,
     1290,  539, 1169, 1170, 1166, 1290,  548, 1163, 1164, 1160,
      410, 1290,  444,  539, 1159, 1158, 1133, 1290,  556, 1151,
     1152, 1148, 1290,  560, 1145, 1148, 1290, 1144, 1290, 1108,
     1117, 1103, 1113, 1110, 1098, 1129, 1128, 1124, 1123, 1090,
     1088, 1085, 1080,  563, 1104, 1290, 1070, 1290,  570, 1064,
      573, 1054,  577, 1042, 1290, 1290,  580, 1032,  584, 1002,
      904,  856,  848,  850,  847,  841,  825,  403,  820,  809,
      828,  793,  818,  811,  808,  797,  795,  770,  753,  749,
      745,  732, 1290,  745,  561,  550, 1290,  551,  547,  546,

      539,  529,  539,  514,  509,  518,  513,  499,  524,  497,
      481,  489,  481,  472,  466, 1290,  481,  493, 1290, 1290,
      462,  463,  433,  437,  436,  428,  195,  179, 1290,  184,
      158,  147,  118, 1290,   74,   52, 1290, 1290,  597,  607,
      617,  627,  637,  647,  657,  667,  677,  687,  697,  707,
      717,  727,  737,  747,  757,  767,  770,  780,  790,  800,
      803,  813,  823,  833,  843,  853,  863,  873,  883,  887,
      892,  895,  905,  915,  925,  928,  937,  947,  957,  967,
      977,  987,  997, 1007, 1017, 1027, 1037, 1047, 1050, 1059,
     1069, 1079, 1089, 1099, 1109, 1116, 1122, 1128, 1134, 1140,

     1146, 1152, 1158, 1164, 1170, 1176, 1182, 1191
    } ;

static const flex_int16_t yy_def[509] =
    {   0,
      439,  439,  440,  440,  438,    5,  441,  441,  442,  443,
      444,  444,  445,  445,  445,  445,  446,  446,  447,  447,
      438,   21,  448,  448,  449,  449,  450,  450,  451,  451,
      452,  452,  453,  453,  438,   35,  438,   37,  454,  454,
      455,  455,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  456,  438,  438,  438,  457,  457,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  458,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  459,  438,
      438,  438,  438,  438,  438,  438,  460,  438,  438,  438,

      461,  461,  462,  438,  438,  463,  438,  438,  464,  438,
      438,  465,  466,  438,  438,  467,  438,  438,  438,  438,
      438,  438,  438,  438,  468,  438,  438,  438,  438,  438,
      438,  469,  470,  438,  471,  438,  438,  438,  438,  438,
      472,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  473,  438,  438,  438,  438,  438,
      438,  438,  474,  438,  438,  456,  438,  475,  438,  438,
      438,  438,  476,  457,  438,  456,  438,  438,  438,  477,
      438,  438,  478,  479,  438,  438,  480,  438,  438,  438,
      481,  482,  438,  483,  438,  458,  438,  484,  438,  438,

      458,  438,  485,  438,  486,  438,  459,  438,  487,  438,
      459,  438,  438,  460,  438,  488,  438,  438,  438,  438,
      489,  461,  438,  460,  462,  438,  463,  438,  464,  438,
      466,  438,  438,  490,  438,  438,  438,  468,  438,  491,
      468,  438,  438,  469,  470,  471,  438,  492,  471,  438,
      438,  493,  438,  438,  438,  438,  438,  472,  438,  494,
      438,  438,  438,  438,  495,  438,  438,  438,  473,  438,
      438,  438,  438,  438,  474,  438,  438,  438,  496,  475,
      475,  438,  438,  438,  476,  438,  438,  477,  438,  478,
      438,  479,  438,  480,  438,  481,  438,  482,  438,  483,

      438,  438,  438,  497,  484,  484,  485,  438,  486,  438,
      438,  438,  498,  487,  487,  438,  438,  499,  488,  488,
      438,  438,  438,  489,  490,  490,  438,  438,  438,  500,
      491,  491,  438,  438,  501,  492,  438,  493,  438,  438,
      438,  438,  438,  438,  438,  494,  494,  495,  495,  438,
      438,  438,  438,  438,  502,  438,  438,  438,  438,  503,
      438,  504,  438,  505,  438,  438,  438,  506,  438,  507,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,

      438,  438,  438,  438,  438,  438,  438,  438,  508,  438,
      438,  438,  438,  438,  438,  438,  438,  508,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,    0,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,

      438,  438,  438,  438,  438,  438,  438,  438
    } ;

static const flex_int16_t yy_nxt[1338] =
    {   0,
      438,  161,   50,   46,   46,  162,   51,   62,   66,   66,
       47,   47,   63,  154,   48,   48,  155,   49,   49,   52,
       53,   52,   54,   52,   52,   55,   52,   52,   52,   56,
       57,   58,   58,   52,   59,   59,   60,   59,   59,   52,
       59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
       59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
       59,   59,   59,   52,   52,   52,   64,   70,  104,  104,
       65,   71,   83,  105,  105,   63,   72,   74,   75,   84,
       83,   76,   86,  271,  272,   77,   85,   84,   88,   78,
      437,   89,   79,  107,   85,   90,  107,   88,  108,  177,

       89,  108,   91,  178,   90,  167,  110,  111,  168,  110,
      111,   91,  437,  175,  114,  115,  176,  114,  115,   80,
      191,   81,   74,   75,  112,  179,   76,  112,  180,   92,
       77,   93,  116,  193,   78,  116,  194,   79,   92,  283,
       93,  118,  119,  118,  119,  436,  124,  156,  181,  120,
      125,  120,  182,  121,  126,  121,  122,  157,  122,  192,
      283,  127,  197,  158,   80,  198,   81,   74,   75,  159,
      124,   76,  143,  144,  125,   77,  435,  161,  126,   78,
      145,  162,   79,  200,  146,  127,  201,  147,  143,  144,
      128,  185,  186,  149,  150,  434,  145,  183,  188,  186,

      146,  151,  189,  147,  261,  152,  262,  190,  153,   80,
      433,   81,   74,   75,  128,  429,   76,  149,  150,  202,
       77,  245,  203,  432,   78,  151,  177,   79,  208,  152,
      178,  209,  153,  245,  210,  187,  184,  211,  215,  245,
      223,  216,  187,  224,  233,  239,  247,  234,  240,  248,
      251,  245,  259,  252,   80,  260,   81,   94,   95,   94,
       96,   94,   94,   97,   94,   94,   94,   98,   99,  100,
      100,   94,  101,  101,  102,  101,  101,   94,  101,  101,
      101,  101,  101,  101,  101,  101,  101,  101,  101,  101,
      101,  101,  101,  101,  101,  101,  101,  101,  101,  101,

      101,   94,   94,   94,  129,  130,  131,  129,  129,  129,
      132,  129,  129,  133,  134,  129,  129,  129,  129,  135,
      135,  135,  135,  135,  129,  133,  135,  135,  135,  135,
      135,  135,  135,  135,  135,  135,  135,  135,  135,  135,
      135,  135,  135,  135,  135,  135,  135,  135,  129,  129,
      129,  136,  137,  138,  136,  136,  136,  136,  136,  136,
      136,  139,  136,  136,  136,  140,  141,  141,  141,  141,
      141,  136,  141,  141,  141,  141,  141,  141,  141,  141,
      141,  141,  141,  141,  141,  141,  141,  141,  141,  141,
      141,  141,  141,  141,  141,  136,  136,  136,  169,  169,

      170,  266,  284,  267,  171,  172,  173,  170,  170,  170,
      282,  283,  264,  171,  172,  265,  284,  165,  171,  185,
      186,  181,  278,  278,  282,  182,  172,  171,  322,  173,
      188,  186,  283,  395,  189,  172,  217,  217,  218,  190,
      396,  323,  219,  220,  221,  218,  218,  218,  342,  322,
      343,  219,  220,  279,  193,  323,  219,  194,  356,  416,
      253,  365,  431,  187,  220,  219,  254,  221,  430,  429,
      255,  256,  356,  220,  187,  365,  257,  169,  169,  170,
      170,  170,  170,  171,  172,  195,  171,  172,  206,  428,
      303,  303,  427,  312,  312,  419,  213,  171,  321,  322,

      171,  317,  317,  426,  425,  172,  424,  423,  172,  217,
      217,  218,  321,  237,  422,  219,  220,  421,  329,  329,
      322,  304,  243,  420,  313,  277,  419,  334,  334,  219,
      354,  354,  318,  218,  218,  218,  417,  220,  302,  219,
      220,  171,  172,  359,  359,  311,  416,  416,  415,  330,
      361,  361,  414,  219,  316,  171,  219,  220,  335,  363,
      363,  220,  328,  172,  413,  412,  333,  367,  367,  277,
      219,  369,  369,  411,  165,  165,  302,  410,  220,  311,
      409,  195,  195,  316,  206,  206,  328,  408,  213,  213,
      333,  237,  237,  407,  406,  243,  243,   44,   44,   44,

       44,   44,   44,   44,   44,   44,   44,   45,   45,   45,
       45,   45,   45,   45,   45,   45,   45,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   66,   66,   66,
       66,   66,   66,   66,   66,   66,   66,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   68,   68,   68,
       68,   68,   68,   68,   68,   68,   68,   73,   73,   73,
       73,   73,   73,   73,   73,   73,   73,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   87,   87,   87,
       87,   87,   87,   87,   87,   87,   87,  103,  103,  103,
      103,  103,  103,  103,  103,  103,  103,  106,  106,  106,

      106,  106,  106,  106,  106,  106,  106,  109,  109,  109,
      109,  109,  109,  109,  109,  109,  109,  113,  113,  113,
      113,  113,  113,  113,  113,  113,  113,  117,  117,  117,
      117,  117,  117,  117,  117,  117,  117,  123,  123,  123,
      123,  123,  123,  123,  123,  123,  123,  142,  142,  142,
      142,  142,  142,  142,  142,  142,  142,  148,  148,  148,
      148,  148,  148,  148,  148,  148,  148,  165,  405,  165,
      404,  165,  165,  165,  165,  165,  165,  174,  174,  174,
      195,  403,  195,  402,  195,  195,  195,  195,  195,  195,
      206,  401,  206,  400,  206,  206,  206,  206,  206,  206,

      213,  333,  213,  328,  213,  213,  213,  213,  213,  213,
      222,  222,  222,  225,  316,  225,  225,  311,  225,  225,
      225,  225,  225,  227,  302,  227,  227,  399,  227,  227,
      227,  227,  227,  229,  277,  398,  229,  229,  229,  229,
      229,  229,  229,  230,  230,  230,  230,  230,  230,  230,
      230,  230,  230,  231,  397,  394,  231,  231,  231,  231,
      231,  231,  231,  232,  232,  232,  232,  232,  232,  232,
      232,  232,  232,  237,  393,  237,  392,  237,  237,  237,
      237,  237,  237,  243,  391,  243,  390,  243,  243,  243,
      243,  243,  243,  246,  389,  246,  246,  249,  249,  249,

      249,  249,  258,  258,  258,  269,  269,  269,  269,  269,
      269,  269,  269,  269,  269,  275,  275,  275,  275,  275,
      275,  275,  275,  275,  275,  280,  388,  280,  280,  280,
      280,  280,  280,  280,  280,  285,  285,  288,  288,  288,
      288,  288,  288,  288,  288,  288,  288,  290,  290,  290,
      290,  290,  290,  290,  290,  290,  290,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  294,  294,  294,
      294,  294,  294,  294,  294,  294,  294,  296,  296,  296,
      296,  296,  296,  296,  296,  296,  296,  298,  298,  298,
      298,  298,  298,  298,  298,  298,  298,  300,  300,  300,

      300,  300,  300,  300,  300,  300,  300,  305,  333,  305,
      305,  305,  305,  305,  305,  305,  305,  307,  307,  307,
      307,  307,  307,  307,  307,  307,  307,  309,  309,  309,
      309,  309,  309,  309,  309,  309,  309,  314,  328,  314,
      314,  314,  314,  314,  314,  314,  314,  319,  316,  319,
      319,  319,  319,  319,  319,  319,  319,  324,  324,  325,
      311,  325,  325,  325,  325,  325,  325,  325,  325,  331,
      302,  331,  331,  331,  331,  331,  331,  331,  331,  336,
      336,  336,  336,  336,  336,  336,  336,  336,  336,  338,
      338,  338,  338,  338,  338,  338,  338,  338,  338,  346,

      382,  346,  346,  346,  346,  346,  346,  346,  346,  348,
      277,  348,  348,  348,  348,  348,  348,  348,  348,  355,
      380,  379,  378,  355,  355,  360,  377,  349,  349,  360,
      360,  362,  347,  347,  376,  362,  362,  364,  375,  374,
      373,  364,  364,  368,  372,  371,  339,  368,  368,  370,
      337,  333,  332,  370,  370,  381,  332,  328,  366,  381,
      381,  383,  326,  326,  320,  383,  383,  384,  320,  316,
      315,  384,  384,  385,  315,  311,  310,  385,  385,  386,
      308,  306,  306,  386,  386,  387,  302,  301,  299,  387,
      387,  418,  418,  418,  418,  418,  418,  418,  418,  418,

      418,  297,  295,  293,  291,  289,  358,  357,  281,  281,
      277,  276,  353,  352,  351,  350,  270,  349,  347,  345,
      344,  341,  340,  339,  250,  337,  333,  242,  238,  332,
      328,  327,  326,  214,  320,  316,  212,  207,  315,  311,
      310,  308,  196,  306,  302,  301,  299,  297,  191,  295,
      293,  291,  183,  289,  287,  286,  166,  281,  277,  164,
      276,  163,  274,  273,  270,  268,  263,  250,  244,  242,
      241,  238,  236,  235,  228,  226,  214,  212,  207,  205,
      204,  199,  196,  166,  164,  163,  160,  438,   69,   43,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,

      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438
    } ;

static const flex_int16_t yy_chk[1338] =
    {   0,
        0,   50,    4,    3,    4,   50,    4,    7,   10,   10,
        3,    4,    7,   47,    3,    4,   47,    3,    4,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    8,   12,   23,   24,
        8,   12,   17,   23,   24,    8,   12,   13,   13,   17,
       18,   13,   18,  156,  156,   13,   17,   18,   19,   13,
      436,   19,   13,   25,   18,   19,   26,   20,   25,   62,

       20,   26,   19,   62,   20,   56,   27,   27,   56,   28,
       28,   20,  435,   60,   29,   29,   60,   30,   30,   13,
       71,   13,   14,   14,   27,   63,   14,   28,   63,   19,
       14,   19,   29,   72,   14,   30,   72,   14,   20,  282,
       20,   31,   31,   32,   32,  433,   33,   48,   64,   31,
       33,   32,   64,   31,   33,   32,   31,   48,   32,   71,
      282,   33,   77,   48,   14,   77,   14,   15,   15,   48,
       34,   15,   39,   39,   34,   15,  432,  161,   34,   15,
       39,  161,   15,   79,   39,   34,   79,   39,   40,   40,
       33,   69,   69,   41,   41,  431,   40,   65,   70,   70,

       40,   41,   70,   40,  146,   41,  146,   70,   41,   15,
      430,   15,   16,   16,   34,  428,   16,   42,   42,   84,
       16,  133,   84,  427,   16,   42,   65,   16,   90,   42,
       65,   90,   42,  133,   91,   69,   65,   91,   98,  245,
      102,   98,   70,  102,  120,  126,  134,  120,  126,  134,
      139,  245,  145,  139,   16,  145,   16,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,

       21,   21,   21,   21,   35,   35,   35,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
       35,   37,   37,   37,   37,   37,   37,   37,   37,   37,
       37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
       37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
       37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
       37,   37,   37,   37,   37,   37,   37,   37,   57,   57,

       57,  152,  172,  152,   57,   57,   57,   58,   58,   58,
      171,  171,  151,   58,   58,  151,  172,  166,   57,  185,
      185,  181,  166,  166,  171,  181,   57,   58,  321,   57,
      188,  188,  171,  378,  188,   58,   99,   99,   99,  188,
      378,  220,   99,   99,   99,  100,  100,  100,  255,  321,
      255,  100,  100,  166,  190,  220,   99,  190,  284,  426,
      140,  323,  425,  185,   99,  100,  140,   99,  424,  423,
      140,  140,  284,  100,  188,  323,  140,  169,  169,  169,
      170,  170,  170,  169,  169,  196,  170,  170,  207,  422,
      196,  196,  421,  207,  207,  418,  214,  169,  219,  219,

      170,  214,  214,  417,  415,  169,  414,  413,  170,  217,
      217,  217,  219,  238,  412,  217,  217,  411,  238,  238,
      219,  196,  244,  410,  207,  278,  409,  244,  244,  217,
      278,  278,  214,  218,  218,  218,  408,  217,  303,  218,
      218,  285,  285,  303,  303,  312,  407,  406,  405,  238,
      312,  312,  404,  218,  317,  285,  324,  324,  244,  317,
      317,  218,  329,  285,  403,  402,  334,  329,  329,  354,
      324,  334,  334,  401,  354,  354,  359,  400,  324,  361,
      399,  359,  359,  363,  361,  361,  367,  398,  363,  363,
      369,  367,  367,  396,  395,  369,  369,  439,  439,  439,

      439,  439,  439,  439,  439,  439,  439,  440,  440,  440,
      440,  440,  440,  440,  440,  440,  440,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  443,  443,  443,
      443,  443,  443,  443,  443,  443,  443,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  445,  445,  445,
      445,  445,  445,  445,  445,  445,  445,  446,  446,  446,
      446,  446,  446,  446,  446,  446,  446,  447,  447,  447,
      447,  447,  447,  447,  447,  447,  447,  448,  448,  448,
      448,  448,  448,  448,  448,  448,  448,  449,  449,  449,

      449,  449,  449,  449,  449,  449,  449,  450,  450,  450,
      450,  450,  450,  450,  450,  450,  450,  451,  451,  451,
      451,  451,  451,  451,  451,  451,  451,  452,  452,  452,
      452,  452,  452,  452,  452,  452,  452,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  454,  454,  454,
      454,  454,  454,  454,  454,  454,  454,  455,  455,  455,
      455,  455,  455,  455,  455,  455,  455,  456,  394,  456,
      392,  456,  456,  456,  456,  456,  456,  457,  457,  457,
      458,  391,  458,  390,  458,  458,  458,  458,  458,  458,
      459,  389,  459,  388,  459,  459,  459,  459,  459,  459,

      460,  387,  460,  386,  460,  460,  460,  460,  460,  460,
      461,  461,  461,  462,  385,  462,  462,  384,  462,  462,
      462,  462,  462,  463,  383,  463,  463,  382,  463,  463,
      463,  463,  463,  464,  381,  380,  464,  464,  464,  464,
      464,  464,  464,  465,  465,  465,  465,  465,  465,  465,
      465,  465,  465,  466,  379,  377,  466,  466,  466,  466,
      466,  466,  466,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  468,  376,  468,  375,  468,  468,  468,
      468,  468,  468,  469,  374,  469,  373,  469,  469,  469,
      469,  469,  469,  470,  372,  470,  470,  471,  471,  471,

      471,  471,  472,  472,  472,  473,  473,  473,  473,  473,
      473,  473,  473,  473,  473,  474,  474,  474,  474,  474,
      474,  474,  474,  474,  474,  475,  371,  475,  475,  475,
      475,  475,  475,  475,  475,  476,  476,  477,  477,  477,
      477,  477,  477,  477,  477,  477,  477,  478,  478,  478,
      478,  478,  478,  478,  478,  478,  478,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  482,  482,  482,
      482,  482,  482,  482,  482,  482,  482,  483,  483,  483,

      483,  483,  483,  483,  483,  483,  483,  484,  370,  484,
      484,  484,  484,  484,  484,  484,  484,  485,  485,  485,
      485,  485,  485,  485,  485,  485,  485,  486,  486,  486,
      486,  486,  486,  486,  486,  486,  486,  487,  368,  487,
      487,  487,  487,  487,  487,  487,  487,  488,  364,  488,
      488,  488,  488,  488,  488,  488,  488,  489,  489,  490,
      362,  490,  490,  490,  490,  490,  490,  490,  490,  491,
      360,  491,  491,  491,  491,  491,  491,  491,  491,  492,
      492,  492,  492,  492,  492,  492,  492,  492,  492,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  494,

      357,  494,  494,  494,  494,  494,  494,  494,  494,  495,
      355,  495,  495,  495,  495,  495,  495,  495,  495,  496,
      353,  352,  351,  496,  496,  497,  350,  349,  348,  497,
      497,  498,  347,  346,  345,  498,  498,  499,  344,  343,
      342,  499,  499,  500,  341,  340,  338,  500,  500,  501,
      336,  335,  332,  501,  501,  502,  331,  330,  327,  502,
      502,  503,  326,  325,  320,  503,  503,  504,  319,  318,
      315,  504,  504,  505,  314,  313,  309,  505,  505,  506,
      307,  306,  305,  506,  506,  507,  304,  300,  298,  507,
      507,  508,  508,  508,  508,  508,  508,  508,  508,  508,

      508,  296,  294,  292,  290,  288,  287,  286,  281,  280,
      279,  275,  274,  273,  272,  271,  269,  265,  260,  257,
      256,  254,  253,  252,  250,  248,  243,  242,  241,  240,
      237,  235,  234,  224,  216,  213,  212,  211,  209,  206,
      205,  203,  201,  198,  195,  194,  192,  191,  189,  187,
      184,  183,  182,  180,  178,  177,  176,  168,  165,  164,
      163,  162,  158,  157,  155,  153,  147,  137,  132,  130,
      127,  125,  122,  121,  108,  105,   97,   95,   89,   86,
       85,   78,   76,   55,   53,   51,   49,   43,   11,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,

      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438
    } ;

static const flex_int16_t yy_rule_linenum[101] =
    {   0,
      116,  121,  126,  130,  134,  138,  142,  148,  152,  164,
      168,  172,  176,  180,  192,  196,  200,  204,  208,  212,
      225,  229,  233,  237,  254,  258,  262,  266,  270,  283,
      287,  291,  292,  293,  294,  295,  299,  303,  316,  321,
      327,  332,  337,  341,  345,  357,  362,  367,  372,  376,
      392,  397,  402,  407,  413,  417,  433,  439,  451,  456,
      461,  466,  471,  475,  479,  483,  501,  506,  511,  515,
      520,  525,  529,  535,  554,  558,  562,  566,  570,  574,
      591,  596,  601,  605,  618,  623,  628,  632,  644,  649,
      653,  669,  673,  689,  696,  700,  705,  721,  727,  731

    } ;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
#line 1 "flex/agc-strip-lexer.ll"










#line 22 "flex/agc-strip-lexer.ll"
/* $Id: agc-strip-lexer.cc 2845 2022-12-13 01:24:39Z teshields $ */

/* This file is part of Ox, an Attribute Grammar Compiling System
   that augments the specification functionality of Lex and Yacc, and
   input specification compatible lexer and parser generators.

   Copyright (C) 1992-1994  Kurt M. Bischoff
   Copyright (C) 2004-2022  Thomas E. Shields

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

#include "config.h"

#include <string>

#include "YY_LOCATIONS.hh"
#line 1007 "flex/agc-strip-lexer.cc"

#line 70 "flex/agc-strip-lexer.ll"
#include "agc-strip-lexer.hh"
#line 1011 "flex/agc-strip-lexer.cc"
#line 1012 "flex/agc-strip-lexer.cc"

#define INITIAL 0
#define GEN 1
#define YACC_TRAILER 2
#define LEX_DEFS 3
#define RULES_PROLOG 4
#define LEX_REGEXP 5
#define LEX_ACT 6
#define GEN_ACT 7
#define LEX_CCODE 8
#define CCODE_BLOCK 9
#define LEX_TRAILER 10
#define COMMENT 11
#define SKIP_COMMENT 12
#define STRING 13
#define SKIP_STRING 14
#define MACRO_DEF 15
#define ATTR_DECL 16
#define ATTR_DECL_SYMS 17
#define TRAV_DECL 18
#define YATTR_REF 19
#define LATTR_REF 20

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
#include <unistd.h>
/* %endif */
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

/* %if-c-only Reentrant structure and macros (non-C++). */
/* %if-reentrant */
/* %if-c-only */
/* %endif */
/* %if-reentrant */
/* %endif */
/* %endif End reentrant structures and macros. */
/* %if-bison-bridge */
/* %endif */
/* %not-for-header */
/* %ok-for-header */

/* %endif */

#ifndef yytext_ptr
static void yy_flex_strncpy ( char *, const char *, int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen ( const char * );
#endif

#ifndef YY_NO_INPUT
/* %if-c-only Standard (non-C++) definition */
/* %not-for-header */
/* %ok-for-header */

/* %endif */
#endif

/* %if-c-only */
/* %endif */

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* %if-c-only Standard (non-C++) definition */
/* %endif */
/* %if-c++-only C++ definition */
#define ECHO LexerOutput( yytext, yyleng )
/* %endif */
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
/* %% [5.0] fread()/read() definition of YY_INPUT goes here unless we're doing C++ \ */\
\
/* %if-c++-only C++ definition \ */\
	if ( (int)(result = LexerInput( (char *) buf, max_size )) < 0 ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
/* %endif */

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
/* %if-c-only */
/* %endif */
/* %if-c++-only */
#define YY_FATAL_ERROR(msg) LexerError( msg )
/* %endif */
#endif

/* %if-tables-serialization structures and prototypes */
/* %not-for-header */
/* %ok-for-header */

/* %not-for-header */
/* %tables-yydmap generated elements */
/* %endif */
/* end tables serialization structures and prototypes */

/* %ok-for-header */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1
/* %if-c-only Standard (non-C++) definition */
/* %endif */
/* %if-c++-only C++ definition */
#define YY_DECL int yyFlexLexer::yylex()
/* %endif */
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK /*LINTED*/break;
#endif

/* %% [6.0] YY_RULE_SETUP definition goes here */
#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

/* %not-for-header */
/** The main scanner function which does all the work.
 */
YY_DECL
{
	yy_state_type yy_current_state;
	char *yy_cp, *yy_bp;
	int yy_act;
    
	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
/* %if-c-only */
/* %endif */
/* %if-c++-only */
			yyin.rdbuf(std::cin.rdbuf());
/* %endif */

		if ( ! yyout )
/* %if-c-only */
/* %endif */
/* %if-c++-only */
			yyout.rdbuf(std::cout.rdbuf());
/* %endif */

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer( yyin, YY_BUF_SIZE );
		}

		yy_load_buffer_state(  );
		}

	{
/* %% [7.0] user's declarations go here */
#line 110 "flex/agc-strip-lexer.ll"


#line 1230 "flex/agc-strip-lexer.cc"

	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
		{
/* %% [8.0] yymore()-related code goes here */
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

/* %% [9.0] code to set up and find next match goes here */
		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)] ;
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 439 )
					yy_c = yy_meta[yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
			++yy_cp;
			}
		while ( yy_current_state != 438 );
		yy_cp = (yy_last_accepting_cpos);
		yy_current_state = (yy_last_accepting_state);

yy_find_action:
/* %% [10.0] code to find the action number goes here */
		yy_act = yy_accept[yy_current_state];

		YY_DO_BEFORE_ACTION;

/* %% [11.0] code for yylineno update goes here */

do_action:	/* This label is used only to access EOF actions. */

/* %% [12.0] debug code goes here */
		if ( yy_flex_debug )
			{
			if ( yy_act == 0 )
				std::cerr << "--scanner backing up\n";
			else if ( yy_act < 101 )
				std::cerr << "--accepting rule at line " << yy_rule_linenum[yy_act] <<
				         "(\"" << yytext << "\")\n";
			else if ( yy_act == 101 )
				std::cerr << "--accepting default rule (\"" << yytext << "\")\n";
			else if ( yy_act == 102 )
				std::cerr << "--(end of buffer or a NUL)\n";
			else
				std::cerr << "--EOF (start condition " << YY_START << ")\n";
			}

		switch ( yy_act )
	{ /* beginning of action switch */
/* %% [13.0] actions go here */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

/* skip Ox-specific content in the Y-file */
case 1:
YY_RULE_SETUP
#line 116 "flex/agc-strip-lexer.ll"
{
  yoxOutG.put (text ());
  yox_push_state (COMMENT, yoxOutG);
}
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 121 "flex/agc-strip-lexer.ll"
{
  yoxOutG.put (text ());
  yox_push_state (STRING, yoxOutG);
}
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 126 "flex/agc-strip-lexer.ll"
{
  push_state (yylloc, ATTR_DECL);
}
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 130 "flex/agc-strip-lexer.ll"
{
  push_state (yylloc, MACRO_DEF);
}
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 134 "flex/agc-strip-lexer.ll"
{
  push_state (yylloc, TRAV_DECL);
}
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 138 "flex/agc-strip-lexer.ll"
{
  push_state (yylloc, YATTR_REF);
}
	YY_BREAK
case 7:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 142 "flex/agc-strip-lexer.ll"
{
  if (++yfileMarkSeen == 2)
    start (YACC_TRAILER);
  yoxOutG.put (text ());
}
	YY_BREAK
case 8:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 148 "flex/agc-strip-lexer.ll"
{
  yoxOutG.put (text ());
}
	YY_BREAK
case 9:
/* rule 9 can match eol */
YY_RULE_SETUP
#line 152 "flex/agc-strip-lexer.ll"
{
  yoxOutG.put ((char)chr ());
}
	YY_BREAK


/* GEN 'subroutine': skip Ox macro definition */
case 10:
YY_RULE_SETUP
#line 164 "flex/agc-strip-lexer.ll"
{
  yox_push_state (SKIP_COMMENT, yoxOutG);
}
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 168 "flex/agc-strip-lexer.ll"
{
  yox_push_state (SKIP_STRING, yoxOutG);
}
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 172 "flex/agc-strip-lexer.ll"
{
  pop_state ();
}
	YY_BREAK
case 13:
/* rule 13 can match eol */
YY_RULE_SETUP
#line 176 "flex/agc-strip-lexer.ll"
{
  yoxOutG.put ((char)chr ());
}
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 180 "flex/agc-strip-lexer.ll"
{
  ; // no-op
}
	YY_BREAK


/* GEN 'subroutine': Ox Y-file attribute reference section */
case 15:
YY_RULE_SETUP
#line 192 "flex/agc-strip-lexer.ll"
{
  yox_push_state (SKIP_COMMENT, yoxOutG);
}
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 196 "flex/agc-strip-lexer.ll"
{
  yox_push_state (SKIP_STRING, yoxOutG);
}
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 200 "flex/agc-strip-lexer.ll"
{
  pop_state ();
}
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 204 "flex/agc-strip-lexer.ll"
{
  unexpectedATLBRACE (yylloc);
}
	YY_BREAK
case 19:
/* rule 19 can match eol */
YY_RULE_SETUP
#line 208 "flex/agc-strip-lexer.ll"
{
  yoxOutG.put ((char)chr ());
}
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 212 "flex/agc-strip-lexer.ll"
{
  ; // no-op
}
	YY_BREAK


/* GEN 'subroutine': skip '@attributes' declaration; the closing brace
     transitions to ATTR_DECL_SYMS, which returns */
case 21:
YY_RULE_SETUP
#line 225 "flex/agc-strip-lexer.ll"
{
  yox_push_state (SKIP_COMMENT, yoxOutG);
}
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 229 "flex/agc-strip-lexer.ll"
{
  start (ATTR_DECL_SYMS);
}
	YY_BREAK
case 23:
/* rule 23 can match eol */
YY_RULE_SETUP
#line 233 "flex/agc-strip-lexer.ll"
{
  yoxOutG.put ((char)chr ());
}
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 237 "flex/agc-strip-lexer.ll"
{
  ; // no-op
}
	YY_BREAK
case YY_STATE_EOF(ATTR_DECL):
#line 241 "flex/agc-strip-lexer.ll"
{
  unterminatedAttrDeclaration (yylloc, startPos.top ());
}
	YY_BREAK


/* GEN 'subroutine': skip grammar symbols in an attribute declaration
     symbol list */
case 25:
YY_RULE_SETUP
#line 254 "flex/agc-strip-lexer.ll"
{
  yox_push_state (SKIP_COMMENT, yoxOutG);
}
	YY_BREAK
case 26:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 258 "flex/agc-strip-lexer.ll"
{
  yoxOutG.put (text ());
}
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 262 "flex/agc-strip-lexer.ll"
{
  ; // no-op
}
	YY_BREAK
case 28:
/* rule 28 can match eol */
YY_RULE_SETUP
#line 266 "flex/agc-strip-lexer.ll"
{
  yoxOutG.put ((char)chr ());
}
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 270 "flex/agc-strip-lexer.ll"
{
  yyless (0);
  pop_state ();
}
	YY_BREAK


/* GEN 'subroutine': skip Ox traversal declaration */
case 30:
YY_RULE_SETUP
#line 283 "flex/agc-strip-lexer.ll"
{
  yox_push_state (SKIP_COMMENT, yoxOutG);
}
	YY_BREAK
case 31:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 287 "flex/agc-strip-lexer.ll"
{
  yoxOutG.put (text ());
}
	YY_BREAK
case 32:
#line 292 "flex/agc-strip-lexer.ll"
case 33:
#line 293 "flex/agc-strip-lexer.ll"
case 34:
#line 294 "flex/agc-strip-lexer.ll"
case 35:
#line 295 "flex/agc-strip-lexer.ll"
case 36:
YY_RULE_SETUP
#line 295 "flex/agc-strip-lexer.ll"
{
  ; // no-op
}
	YY_BREAK
case 37:
/* rule 37 can match eol */
YY_RULE_SETUP
#line 299 "flex/agc-strip-lexer.ll"
{
  yoxOutG.put ((char)chr ());
}
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 303 "flex/agc-strip-lexer.ll"
{
  yyless (0);
  pop_state ();
}
	YY_BREAK


/* L-file Definitions Section */
case 39:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 316 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  push_state (yylloc, LEX_CCODE);
}
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 321 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  push_state (yylloc, CCODE_BLOCK);
  nLbraces = 0;
}
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 327 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  yox_push_state (COMMENT, yoxOutL);
}
	YY_BREAK
case 42:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 332 "flex/agc-strip-lexer.ll"
{
  start (RULES_PROLOG);
  yoxOutL.put (text ());
}
	YY_BREAK
case 43:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 337 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
}
	YY_BREAK
case 44:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 341 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
}
	YY_BREAK
case 45:
/* rule 45 can match eol */
YY_RULE_SETUP
#line 345 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put ((char)chr ());
}
	YY_BREAK


/* LEX_DEFS, LEX_REGEXP 'subroutine': echo C code between "%{" and "%}" */
case 46:
YY_RULE_SETUP
#line 357 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  yox_push_state (COMMENT, yoxOutL);
}
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 362 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  yox_push_state (STRING, yoxOutL);
}
	YY_BREAK
case 48:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 367 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  pop_state ();
}
	YY_BREAK
case 49:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 372 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
}
	YY_BREAK
case 50:
/* rule 50 can match eol */
YY_RULE_SETUP
#line 376 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put ((char)chr ());
}
	YY_BREAK
case YY_STATE_EOF(LEX_CCODE):
#line 380 "flex/agc-strip-lexer.ll"
{
  unterminatedCode (yylloc, startPos.top ());
}
	YY_BREAK


/* LEX_DEFS 'subroutine': echo C code "{ ... }" for 'flex' extension "%top" */
case 51:
YY_RULE_SETUP
#line 392 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  yox_push_state (COMMENT, yoxOutL);
}
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 397 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  yox_push_state (STRING, yoxOutL);
}
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 402 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put ((char)chr ());
  nLbraces++;
}
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 407 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put ((char)chr ());
  if (--nLbraces == 0)
    pop_state ();
}
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 413 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
}
	YY_BREAK
case 56:
/* rule 56 can match eol */
YY_RULE_SETUP
#line 417 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put ((char)chr ());
}
	YY_BREAK
case YY_STATE_EOF(CCODE_BLOCK):
#line 421 "flex/agc-strip-lexer.ll"
{
  unterminatedCode (yylloc, startPos.top ());
}
	YY_BREAK


/* echo the prolog of the Lex Rules Section */
case 57:
YY_RULE_SETUP
#line 433 "flex/agc-strip-lexer.ll"
{
  yyless (0);
  start (LEX_REGEXP);
  nLbraces = 0;
}
	YY_BREAK
case 58:
/* rule 58 can match eol */
YY_RULE_SETUP
#line 439 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put ((char)chr ());
}
	YY_BREAK


/* echo Lex regular expressions, terminated by whitespace */
case 59:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 451 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  start (LEX_TRAILER);
}
	YY_BREAK
case 60:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 456 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  push_state (yylloc, LEX_CCODE);
}
	YY_BREAK
case 61:
YY_RULE_SETUP
#line 461 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  yox_push_state (COMMENT, yoxOutL);
}
	YY_BREAK
case 62:
YY_RULE_SETUP
#line 466 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  push_state (yylloc, LEX_ACT);
}
	YY_BREAK
case 63:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 471 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
}
	YY_BREAK
case 64:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 475 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
}
	YY_BREAK
case 65:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 479 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
}
	YY_BREAK
case 66:
/* rule 66 can match eol */
YY_RULE_SETUP
#line 483 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put ((char)chr ());
}
	YY_BREAK


/* GEN_ACT: initial start condition if "theFiles.scanner == GEN_SPEC_LEXER" */
/* LEX_ACT: LEX_REGEXP 'subroutine' */
/* look for the start of an L-file attribute reference section (which sends
     this lexer to LATTR_REF), and look for the end of a Lex action after an
     attribute reference section; a Lex action is terminated by the first
     newline outside of paired braces */
case 67:
YY_RULE_SETUP
#line 501 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  yox_push_state (COMMENT, yoxOutL);
}
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 506 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  yox_push_state (STRING, yoxOutL);
}
	YY_BREAK
case 69:
YY_RULE_SETUP
#line 511 "flex/agc-strip-lexer.ll"
{
  push_state (yylloc, LATTR_REF);
}
	YY_BREAK
case 70:
YY_RULE_SETUP
#line 515 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put ((char)chr ());
  nLbraces++;
}
	YY_BREAK
case 71:
YY_RULE_SETUP
#line 520 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put ((char)chr ());
  nLbraces--;
}
	YY_BREAK
case 72:
YY_RULE_SETUP
#line 525 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
}
	YY_BREAK
case 73:
/* rule 73 can match eol */
YY_RULE_SETUP
#line 529 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put ((char)chr ());
  if ((start () == LEX_ACT) && (nLbraces == 0))
    pop_state ();
}
	YY_BREAK
case 74:
YY_RULE_SETUP
#line 535 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put ((char)chr ());
}
	YY_BREAK
case YY_STATE_EOF(GEN_ACT):
case YY_STATE_EOF(LEX_ACT):
#line 539 "flex/agc-strip-lexer.ll"
{
  if (start () == LEX_ACT)
    unterminatedAction (yylloc, startPos.top ());

  return lexer::token::END;
}
	YY_BREAK


/* LEX_ACT 'subroutine': skip Ox L-file attribute reference section */
case 75:
YY_RULE_SETUP
#line 554 "flex/agc-strip-lexer.ll"
{
  yox_push_state (SKIP_COMMENT, yoxOutL);
}
	YY_BREAK
case 76:
YY_RULE_SETUP
#line 558 "flex/agc-strip-lexer.ll"
{
  yox_push_state (SKIP_STRING, yoxOutL);
}
	YY_BREAK
case 77:
YY_RULE_SETUP
#line 562 "flex/agc-strip-lexer.ll"
{
  pop_state ();
}
	YY_BREAK
case 78:
YY_RULE_SETUP
#line 566 "flex/agc-strip-lexer.ll"
{
  unexpectedATLBRACE (yylloc);
}
	YY_BREAK
case 79:
/* rule 79 can match eol */
YY_RULE_SETUP
#line 570 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put ((char)chr ());
}
	YY_BREAK
case 80:
YY_RULE_SETUP
#line 574 "flex/agc-strip-lexer.ll"
{
  ; // no-op
}
	YY_BREAK
case YY_STATE_EOF(LATTR_REF):
#line 578 "flex/agc-strip-lexer.ll"
{
  unterminatedAttrRefSection (yylloc, startPos.top ());
}
	YY_BREAK


/* echo the optional user section following the second "%%" in the Y-file,
     if present */
case 81:
YY_RULE_SETUP
#line 591 "flex/agc-strip-lexer.ll"
{
  yoxOutG.put (text ());
  yox_push_state (COMMENT, yoxOutG);
}
	YY_BREAK
case 82:
YY_RULE_SETUP
#line 596 "flex/agc-strip-lexer.ll"
{
  yoxOutG.put (text ());
  yox_push_state (STRING, yoxOutG);
}
	YY_BREAK
case 83:
YY_RULE_SETUP
#line 601 "flex/agc-strip-lexer.ll"
{
  yoxOutG.put (text ());
}
	YY_BREAK
case 84:
/* rule 84 can match eol */
YY_RULE_SETUP
#line 605 "flex/agc-strip-lexer.ll"
{
  yoxOutG.put ((char)chr ());
}
	YY_BREAK


/* echo the optional user section following the second "%%" in the L-file,
     if present */
case 85:
YY_RULE_SETUP
#line 618 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  yox_push_state (COMMENT, yoxOutL);
}
	YY_BREAK
case 86:
YY_RULE_SETUP
#line 623 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
  yox_push_state (STRING, yoxOutL);
}
	YY_BREAK
case 87:
YY_RULE_SETUP
#line 628 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put (text ());
}
	YY_BREAK
case 88:
/* rule 88 can match eol */
YY_RULE_SETUP
#line 632 "flex/agc-strip-lexer.ll"
{
  yoxOutL.put ((char)chr ());
}
	YY_BREAK


/* 'subroutine': handle multi-line C comments */
case 89:
YY_RULE_SETUP
#line 644 "flex/agc-strip-lexer.ll"
{
  whereTo->put (text ());
  pop_state ();
}
	YY_BREAK
case 90:
YY_RULE_SETUP
#line 649 "flex/agc-strip-lexer.ll"
{
  whereTo->put (text ());
}
	YY_BREAK
case 91:
/* rule 91 can match eol */
YY_RULE_SETUP
#line 653 "flex/agc-strip-lexer.ll"
{
  whereTo->put ((char)chr ());
}
	YY_BREAK
case YY_STATE_EOF(COMMENT):
#line 657 "flex/agc-strip-lexer.ll"
{
  unterminatedComment (yylloc, startPos.top ());
}
	YY_BREAK


/* 'subroutine': skip multi-line C comments */
case 92:
YY_RULE_SETUP
#line 669 "flex/agc-strip-lexer.ll"
{
  pop_state ();
}
	YY_BREAK
case 93:
/* rule 93 can match eol */
YY_RULE_SETUP
#line 673 "flex/agc-strip-lexer.ll"
{
  ; // no-op
}
	YY_BREAK
case YY_STATE_EOF(SKIP_COMMENT):
#line 677 "flex/agc-strip-lexer.ll"
{
  unterminatedComment (yylloc, startPos.top ());
}
	YY_BREAK


/* 'subroutine': handle multi-lint C/C++ string literals */
case 94:
YY_RULE_SETUP
#line 689 "flex/agc-strip-lexer.ll"
{
  whereTo->put ((char)chr ());
  if (stringHasBareNewline)
    stringContainsNewline (yylloc, startPos.top ());
  pop_state ();
}
	YY_BREAK
case 95:
/* rule 95 can match eol */
YY_RULE_SETUP
#line 696 "flex/agc-strip-lexer.ll"
{
  whereTo->put (text ());
}
	YY_BREAK
case 96:
/* rule 96 can match eol */
YY_RULE_SETUP
#line 700 "flex/agc-strip-lexer.ll"
{
  stringHasBareNewline = true;
  whereTo->put ((char)chr ());
}
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 705 "flex/agc-strip-lexer.ll"
{
  whereTo->put ((char)chr ());
}
	YY_BREAK
case YY_STATE_EOF(STRING):
#line 709 "flex/agc-strip-lexer.ll"
{
  unterminatedString (yylloc, startPos.top ());
}
	YY_BREAK


/* 'subroutine': skip multi-lint C/C++ string literals */
case 98:
YY_RULE_SETUP
#line 721 "flex/agc-strip-lexer.ll"
{
  if (stringHasBareNewline)
    stringContainsNewline (yylloc, startPos.top ());
  pop_state ();
}
	YY_BREAK
case 99:
/* rule 99 can match eol */
YY_RULE_SETUP
#line 727 "flex/agc-strip-lexer.ll"
{
  stringHasBareNewline = true;
}
	YY_BREAK
case 100:
/* rule 100 can match eol */
YY_RULE_SETUP
#line 731 "flex/agc-strip-lexer.ll"
{
  ; // no-op
}
	YY_BREAK
case YY_STATE_EOF(SKIP_STRING):
#line 735 "flex/agc-strip-lexer.ll"
{
  unterminatedString (yylloc, startPos.top ());
}
	YY_BREAK

case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(GEN):
case YY_STATE_EOF(YACC_TRAILER):
case YY_STATE_EOF(LEX_DEFS):
case YY_STATE_EOF(RULES_PROLOG):
case YY_STATE_EOF(LEX_REGEXP):
case YY_STATE_EOF(LEX_TRAILER):
case YY_STATE_EOF(MACRO_DEF):
case YY_STATE_EOF(ATTR_DECL_SYMS):
case YY_STATE_EOF(TRAV_DECL):
case YY_STATE_EOF(YATTR_REF):
#line 743 "flex/agc-strip-lexer.ll"
{
  return lexer::token::END;
}
	YY_BREAK
case 101:
YY_RULE_SETUP
#line 747 "flex/agc-strip-lexer.ll"
ECHO;
	YY_BREAK
#line 2238 "flex/agc-strip-lexer.cc"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
/* %if-c-only */
/* %endif */
/* %if-c++-only */
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin.rdbuf();
/* %endif */
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
/* %% [14.0] code to do back-up for compressed tables and set up yy_cp goes here */
				yy_cp = (yy_last_accepting_cpos);
				yy_current_state = (yy_last_accepting_state);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap(  ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of user's declarations */
} /* end of yylex */
/* %ok-for-header */

/* %if-c++-only */
/* %not-for-header */
/* The contents of this function are C++ specific, so the () macro is not used.
 * This constructor simply maintains backward compatibility.
 * DEPRECATED
 */
yyFlexLexer::yyFlexLexer( std::istream* arg_yyin, std::ostream* arg_yyout ):
	yyin(arg_yyin ? arg_yyin->rdbuf() : std::cin.rdbuf()),
	yyout(arg_yyout ? arg_yyout->rdbuf() : std::cout.rdbuf())
{
	ctor_common();
}

/* The contents of this function are C++ specific, so the () macro is not used.
 */
yyFlexLexer::yyFlexLexer( std::istream& arg_yyin, std::ostream& arg_yyout ):
	yyin(arg_yyin.rdbuf()),
	yyout(arg_yyout.rdbuf())
{
	ctor_common();
}

/* The contents of this function are C++ specific, so the () macro is not used.
 */
void yyFlexLexer::ctor_common()
{
	yy_c_buf_p = 0;
	yy_init = 0;
	yy_start = 0;
	yy_flex_debug = 0;
	yylineno = 1;	// this will only get updated if %option yylineno

	yy_did_buffer_switch_on_eof = 0;

	yy_looking_for_trail_begin = 0;
	yy_more_flag = 0;
	yy_more_len = 0;
	yy_more_offset = yy_prev_more_offset = 0;

	yy_start_stack_ptr = yy_start_stack_depth = 0;
	yy_start_stack = NULL;

	yy_buffer_stack = NULL;
	yy_buffer_stack_top = 0;
	yy_buffer_stack_max = 0;

	yy_state_buf = 0;

}

/* The contents of this function are C++ specific, so the () macro is not used.
 */
yyFlexLexer::~yyFlexLexer()
{
	delete [] yy_state_buf;
	yyfree( yy_start_stack  );
	yy_delete_buffer( YY_CURRENT_BUFFER );
	yyfree( yy_buffer_stack  );
}

/* The contents of this function are C++ specific, so the () macro is not used.
 */
void yyFlexLexer::switch_streams( std::istream& new_in, std::ostream& new_out )
{
	// was if( new_in )
	yy_delete_buffer( YY_CURRENT_BUFFER );
	yy_switch_to_buffer( yy_create_buffer( new_in, YY_BUF_SIZE  ) );

	// was if( new_out )
	yyout.rdbuf(new_out.rdbuf());
}

/* The contents of this function are C++ specific, so the () macro is not used.
 */
void yyFlexLexer::switch_streams( std::istream* new_in, std::ostream* new_out )
{
	if( ! new_in ) {
		new_in = &yyin;
	}

	if ( ! new_out ) {
		new_out = &yyout;
	}

	switch_streams(*new_in, *new_out);
}

#ifdef YY_INTERACTIVE
int yyFlexLexer::LexerInput( char* buf, int /* max_size */ )
#else
int yyFlexLexer::LexerInput( char* buf, int max_size )
#endif
{
	if ( yyin.eof() || yyin.fail() )
		return 0;

#ifdef YY_INTERACTIVE
	yyin.get( buf[0] );

	if ( yyin.eof() )
		return 0;

	if ( yyin.bad() )
		return -1;

	return 1;

#else
	(void) yyin.read( buf, max_size );

	if ( yyin.bad() )
		return -1;
	else
		return yyin.gcount();
#endif
}

void yyFlexLexer::LexerOutput( const char* buf, int size )
{
	(void) yyout.write( buf, size );
}
/* %ok-for-header */

/* %endif */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
int yyFlexLexer::yy_get_next_buffer()
/* %endif */
{
    	char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	char *source = (yytext_ptr);
	int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr) - 1);

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER_LVALUE;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc( (void *) b->yy_ch_buf,
							 (yy_size_t) (b->yy_buf_size + 2)  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = NULL;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if (((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		int new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc(
			(void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf, (yy_size_t) new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
		/* "- 2" to take care of EOB's */
		YY_CURRENT_BUFFER_LVALUE->yy_buf_size = (int) (new_size - 2);
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

/* %if-c-only */
/* %not-for-header */
/* %endif */
/* %if-c++-only */
    yy_state_type yyFlexLexer::yy_get_previous_state()
/* %endif */
{
	yy_state_type yy_current_state;
	char *yy_cp;
    
/* %% [15.0] code to get the start state into yy_current_state goes here */
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
/* %% [16.0] code to find the next state goes here */
		YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 439 )
				yy_c = yy_meta[yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    yy_state_type yyFlexLexer::yy_try_NUL_trans( yy_state_type yy_current_state )
/* %endif */
{
	int yy_is_jam;
    /* %% [17.0] code to find the next state, and perhaps do backing up, goes here */
	char *yy_cp = (yy_c_buf_p);

	YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 439 )
			yy_c = yy_meta[yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
	yy_is_jam = (yy_current_state == 438);

		return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_UNPUT
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yyunput( int c, char* yy_bp)
/* %endif */
{
	char *yy_cp;
    
    yy_cp = (yy_c_buf_p);

	/* undo effects of setting up yytext */
	*yy_cp = (yy_hold_char);

	if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		int number_to_move = (yy_n_chars) + 2;
		char *dest = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[
					YY_CURRENT_BUFFER_LVALUE->yy_buf_size + 2];
		char *source =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move];

		while ( source > YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars =
			(yy_n_chars) = (int) YY_CURRENT_BUFFER_LVALUE->yy_buf_size;

		if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;

/* %% [18.0] update yylineno here */

	(yytext_ptr) = yy_bp;
	(yy_hold_char) = *yy_cp;
	(yy_c_buf_p) = yy_cp;
}
/* %if-c-only */
/* %endif */
#endif

/* %if-c-only */
/* %endif */
/* %if-c++-only */
    int yyFlexLexer::yyinput()
/* %endif */
{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (int) ((yy_c_buf_p) - (yytext_ptr));
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap(  ) )
						return 0;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

/* %% [19.0] update BOL and yylineno */
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');

	return c;
}
/* %if-c-only */
/* %endif */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yyrestart( std::istream& input_file )
/* %endif */
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer( yyin, YY_BUF_SIZE );
	}

	yy_init_buffer( YY_CURRENT_BUFFER, input_file );
	yy_load_buffer_state(  );
}

/* %if-c++-only */
/** Delegate to the new version that takes an istream reference.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
void yyFlexLexer::yyrestart( std::istream* input_file )
{
	if( ! input_file ) {
		input_file = &yyin;
	}
	yyrestart( *input_file );
}
/* %endif */

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
/* %endif */
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state(  );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yy_load_buffer_state()
/* %endif */
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
/* %if-c-only */
/* %endif */
/* %if-c++-only */
	yyin.rdbuf(YY_CURRENT_BUFFER_LVALUE->yy_input_file);
/* %endif */
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    YY_BUFFER_STATE yyFlexLexer::yy_create_buffer( std::istream& file, int size )
/* %endif */
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc( (yy_size_t) (b->yy_buf_size + 2)  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
}

/* %if-c++-only */
/** Delegate creation of buffers to the new version that takes an istream reference.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
	YY_BUFFER_STATE yyFlexLexer::yy_create_buffer( std::istream* file, int size )
{
	return yy_create_buffer( *file, size );
}
/* %endif */

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yy_delete_buffer( YY_BUFFER_STATE b )
/* %endif */
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree( (void *) b->yy_ch_buf  );

	yyfree( (void *) b  );
}

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yy_init_buffer( YY_BUFFER_STATE b, std::istream& file )
/* %endif */

{
	int oerrno = errno;
    
	yy_flush_buffer( b );

/* %if-c-only */
/* %endif */
/* %if-c++-only */
	b->yy_input_file = file.rdbuf();
/* %endif */
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

/* %if-c-only */
/* %endif */
/* %if-c++-only */
	b->yy_is_interactive = 0;
/* %endif */
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yy_flush_buffer( YY_BUFFER_STATE b )
/* %endif */
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state(  );
}

/* %if-c-or-c++ */
/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
void yyFlexLexer::yypush_buffer_state (YY_BUFFER_STATE new_buffer)
/* %endif */
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state(  );
	(yy_did_buffer_switch_on_eof) = 1;
}
/* %endif */

/* %if-c-or-c++ */
/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
void yyFlexLexer::yypop_buffer_state (void)
/* %endif */
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state(  );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}
/* %endif */

/* %if-c-or-c++ */
/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
/* %if-c-only */
/* %endif */
/* %if-c++-only */
void yyFlexLexer::yyensure_buffer_stack(void)
/* %endif */
{
	yy_size_t num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
      num_to_alloc = 1; /* After all that talk, this was set to 1 anyways... */
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));

		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		yy_size_t grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}
/* %endif */

/* %if-c-only */
/* %endif */

/* %if-c-only */
/* %endif */

/* %if-c-only */
/* %endif */

/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yy_push_state( int _new_state )
/* %endif */
{
    	if ( (yy_start_stack_ptr) >= (yy_start_stack_depth) )
		{
		yy_size_t new_size;

		(yy_start_stack_depth) += YY_START_STACK_INCR;
		new_size = (yy_size_t) (yy_start_stack_depth) * sizeof( int );

		if ( ! (yy_start_stack) )
			(yy_start_stack) = (int *) yyalloc( new_size  );

		else
			(yy_start_stack) = (int *) yyrealloc(
					(void *) (yy_start_stack), new_size  );

		if ( ! (yy_start_stack) )
			YY_FATAL_ERROR( "out of memory expanding start-condition stack" );
		}

	(yy_start_stack)[(yy_start_stack_ptr)++] = YY_START;

	BEGIN(_new_state);
}

/* %if-c-only */
/* %endif */
/* %if-c++-only */
    void yyFlexLexer::yy_pop_state()
/* %endif */
{
    	if ( --(yy_start_stack_ptr) < 0 )
		YY_FATAL_ERROR( "start-condition stack underflow" );

	BEGIN((yy_start_stack)[(yy_start_stack_ptr)]);
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

/* %if-c-only */
/* %endif */
/* %if-c++-only */
void yyFlexLexer::LexerError( const char* msg )
{
    	std::cerr << msg << std::endl;
	exit( YY_EXIT_FAILURE );
}
/* %endif */

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/* %if-c-only */
/* %if-reentrant */
/* %endif */
/* %if-reentrant */
/* %endif */
/* %endif */

/* %if-reentrant */
/* %if-bison-bridge */
/* %endif */
/* %endif if-c-only */

/* %if-c-only */
/* %endif */

/* %if-c-only SNIP! this currently causes conflicts with the c++ scanner */
/* %if-reentrant */
/* %endif */
/* %endif */

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, const char * s2, int n )
{
		
	int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (const char * s )
{
	int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
			return malloc(size);
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
		
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return realloc(ptr, size);
}

void yyfree (void * ptr )
{
			free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

/* %if-tables-serialization definitions */
/* %define-yytables   The name for this specific scanner's tables. */
#define YYTABLES_NAME "yytables"
/* %endif */

/* %ok-for-header */

#line 747 "flex/agc-strip-lexer.ll"


// strip lexer constructor
AGC::STRIP::Lexer::Lexer (specIO& fR, std::ifstream& yoxIn)
    : theFiles (fR),
      EOLstate (EOLctx (position (&fR.inName, 0, 0)))
{
  yycolumn = 1;

  nLbraces = 0;

  yfileMarkSeen = 0;

  yyrestart (yoxIn);

  if (theFiles.scanner == YACC_SPEC_LEXER)
    {
      start (GEN);
      return;
    }

  switch (theFiles.scanner)
    {
    case LEX_SPEC_LEXER:
      start (LEX_DEFS);
      break;
    case GEN_SPEC_LEXER:
      start (GEN_ACT);
      break;
    default:
      break;
    }
}

namespace AGC
{
namespace STRIP
{
#if defined(_WIN32)
#include "YY_INPUT.hh"
#endif

void
Lexer::yox_push_state (int lexState, outMgr& whTo)
{
  whereTo = &whTo;
  if (lexState == STRING || lexState == SKIP_STRING)
    stringHasBareNewline = false;
  push_state (*whereTo->getCurPos (), lexState);
}

}
}

