// reflex/agc-strip-internal.hh generated by reflex 3.2.11 from reflex/agc-strip-lexer.ll

#ifndef REFLEX_REFLEX_AGC_STRIP_INTERNAL_HH
#define REFLEX_REFLEX_AGC_STRIP_INTERNAL_HH
#define IN_HEADER 1
#define REFLEX_VERSION "3.2.11"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  OPTIONS USED                                                              //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#undef REFLEX_OPTION_YYLTYPE
#undef REFLEX_OPTION_YYSTYPE
#undef REFLEX_OPTION_bison_cc
#undef REFLEX_OPTION_bison_cc_namespace
#undef REFLEX_OPTION_bison_cc_parser
#undef REFLEX_OPTION_bison_locations
#undef REFLEX_OPTION_ctorarg
#undef REFLEX_OPTION_ctorinit
#undef REFLEX_OPTION_debug
#undef REFLEX_OPTION_full
#undef REFLEX_OPTION_header_file
#undef REFLEX_OPTION_lex
#undef REFLEX_OPTION_lexer
#undef REFLEX_OPTION_namespace
#undef REFLEX_OPTION_outfile

#define REFLEX_OPTION_YYLTYPE             AGC::location
#define REFLEX_OPTION_YYSTYPE             AGC::lexer::value_type
#define REFLEX_OPTION_bison_cc            true
#define REFLEX_OPTION_bison_cc_namespace  AGC
#define REFLEX_OPTION_bison_cc_parser     lexer
#define REFLEX_OPTION_bison_locations     true
#define REFLEX_OPTION_ctorarg             specIO& fR
#define REFLEX_OPTION_ctorinit            theFiles (fR), EOLstate (EOLctx (position (&fR.inName, 0, 0)))
#define REFLEX_OPTION_debug               true
#define REFLEX_OPTION_full                true
#define REFLEX_OPTION_header_file         "reflex/agc-strip-internal.hh"
#define REFLEX_OPTION_lex                 yylex
#define REFLEX_OPTION_lexer               strip_Lexer
#define REFLEX_OPTION_namespace           AGC::STRIP
#define REFLEX_OPTION_outfile             "reflex/agc-strip-lexer.cc"

// --debug option enables ASSERT:
#define ASSERT(c) assert(c)

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  SECTION 1: %top user code                                                 //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#line 47 "reflex/agc-strip-lexer.ll"

#if CAN_SET_WITH_REALLOC
#define WITH_REALLOC 0
#endif

#include <fstream>
#include <stack>

#include "agc-Lfile.hh"
#include "messages.hh"
#include "opts.hh"
#include "outMgr.hh"
#include "scan.hh"


////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  REGEX MATCHER                                                             //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#include <reflex/matcher.h>

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  ABSTRACT LEXER CLASS                                                      //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#include <reflex/abslexer.h>

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  LEXER CLASS                                                               //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

namespace AGC {
namespace STRIP {

class strip_Lexer : public reflex::AbstractLexer<reflex::Matcher> {
#line 62 "reflex/agc-strip-lexer.ll"

protected:

  inline void
  push_state (const position& pos, int new_state)
  {
    AbstractLexer::push_state (new_state);
    startPos.push (pos); // starting position if EOF in 'new_state'
  }

  inline void
  push_state (const location& loc, int new_state)
  {
    AbstractLexer::push_state (new_state);
    startPos.push (loc.begin); // starting position if EOF in 'new_state'
  }

  inline void
  pop_state (void)
  {
    AbstractLexer::pop_state ();
    startPos.pop ();
  }

  specIO& theFiles;

  EOLctx EOLstate;

private:

  int nLbraces; // '{' ... '}' nesting

  int yfileMarkSeen; // count of "%%" in the Y-file

  outMgr* whereTo;
  void yox_push_state (int, outMgr&);

  std::stack<position> startPos;

  bool stringHasBareNewline;

 public:
  typedef reflex::AbstractLexer<reflex::Matcher> AbstractBaseLexer;
  strip_Lexer(
      specIO& fR,
      // a persistent source of input, empty by default
      const reflex::Input& input = reflex::Input(),
      // optional output stream, std::cout by default
      std::ostream& os = std::cout)
    :
      AbstractBaseLexer(input, os),
      theFiles (fR), EOLstate (EOLctx (position (&fR.inName, 0, 0)))
  {
#line 107 "reflex/agc-strip-lexer.ll"

    nLbraces = 0;

    yfileMarkSeen = 0;

    if (theFiles.scanner == YACC_SPEC_LEXER)
      {
        start (GEN);
        return;
      }

    switch (theFiles.scanner)
      {
      case LEX_SPEC_LEXER:
        start (LEX_DEFS);
        break;
      case GEN_SPEC_LEXER:
        start (GEN_ACT);
        break;
      default:
        break;
      }

    set_debug(true);
  }
  static const int INITIAL = 0;
  static const int GEN = 1;
  static const int YACC_TRAILER = 2;
  static const int LEX_DEFS = 3;
  static const int RULES_PROLOG = 4;
  static const int LEX_REGEXP = 5;
  static const int LEX_ACT = 6;
  static const int GEN_ACT = 7;
  static const int LEX_CCODE = 8;
  static const int CCODE_BLOCK = 9;
  static const int LEX_TRAILER = 10;
  static const int COMMENT = 11;
  static const int SKIP_COMMENT = 12;
  static const int STRING = 13;
  static const int SKIP_STRING = 14;
  static const int MACRO_DEF = 15;
  static const int ATTR_DECL = 16;
  static const int ATTR_DECL_SYMS = 17;
  static const int TRAV_DECL = 18;
  static const int YATTR_REF = 19;
  static const int LATTR_REF = 20;
  // bison-cc bison-locations: yylloc_update() tracks lexeme locations
  virtual void yylloc_update(AGC::location& yylloc)
  {
    yylloc.begin.line = static_cast<unsigned int>(matcher().lineno());
    yylloc.begin.column = static_cast<unsigned int>(matcher().columno());
    yylloc.end.line = static_cast<unsigned int>(matcher().lineno_end());
    yylloc.end.column = static_cast<unsigned int>(matcher().columno_end());
  }
  virtual int yylex(AGC::lexer::value_type *lvalp, AGC::location *llocp)
  {
    return yylex(*lvalp, *llocp);
  }
  // the bison-cc bison-locations lexer function defined by SECTION 2
  virtual int yylex(AGC::lexer::value_type& yylval, AGC::location& yylloc);
};

} // namespace AGC
} // namespace STRIP

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//  BISON C++                                                                 //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////


#endif
