/* $Id: type-keywords.hh 2834 2022-12-10 21:33:22Z teshields $ */

/* This file is part of Ox, an Attribute Grammar Compiling System
   that augments the specification functionality of Lex and Yacc, and
   input specification compatible lexer and parser generators.

   Copyright (C) 2020-2022  Thomas E. Shields

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

#ifndef TYPE_KEYWORDS_HH_INCLUDED
#define TYPE_KEYWORDS_HH_INCLUDED

#include <cstdlib>

#include "agc-Yfile.hh"

typedef struct type_keyword
{
  const char* name;
  AGC::parser::token_kind_type token;
} type_keyword;
extern const struct type_keyword* in_type_keyword_set (const char*, size_t);

#define register /**/

#endif // !TYPE_KEYWORDS_HH_INCLUDED
