/* $Id: yox-directives.hh 2834 2022-12-10 21:33:22Z teshields $ */

/* This file is part of Ox, an Attribute Grammar Compiling System
   that augments the specification functionality of Lex and Yacc, and
   input specification compatible lexer and parser generators.

   Copyright (C) 2020-2022  Thomas E. Shields

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

#ifndef YOX_DIRECTIVES_HH_INCLUDED
#define YOX_DIRECTIVES_HH_INCLUDED

#include <cstdlib>

#include "agc-Yfile.hh"

enum yox_directive_param_type
{
  C_int,
  C_string,
  other
};

typedef struct yox_directive
{
  const char* name;
  AGC::parser::token_kind_type token;
  enum yox_directive_param_type param_type;
} yox_directive;

extern const struct yox_directive* in_yox_directive_set (const char*, size_t);

#define register /**/

#endif // !YOX_DIRECTIVES_HH_INCLUDED
