/* $Id: agc.Y 462 2017-09-03 21:36:56Z Tom Shields $ */ 
/* RCS Log:	agc.y,v
 * Revision 9.3  91/04/19  08:26:19  08:26:19  bischoff (Kurt Bischoff)
 * put in an exit(0) statement so that yox returns all-clear if that is the
 * case. 
 * 
 * Revision 9.2  91/04/19  08:02:29  08:02:29  bischoff (Kurt Bischoff)
 * *** empty log message ***
 * 
 * Revision 9.1  91/04/13  03:16:02  03:16:02  bischoff (Kurt Bischoff)
 * *** empty log message ***
 * 
 * Revision 8.5  91/04/12  03:09:13  03:09:13  bischoff (Kurt Bischoff)
 * *** empty log message ***
 * 
 * Revision 8.1  91/04/10  09:50:16  09:50:16  bischoff (Kurt Bischoff)
 * *** empty log message ***
 * 
 * Revision 7.4  91/04/10  03:21:09  03:21:09  bischoff (Kurt Bischoff)
 * *** empty log message ***
 * 
 * Revision 7.3  91/04/10  03:12:31  03:12:31  bischoff (Kurt Bischoff)
 * *** empty log message ***
 * 
 * Revision 7.2  90/09/23  05:31:45  05:31:45  bischoff (Kurt Bischoff)
 * Changed the 'pet' symbol of yox from '$' to '@' 
 * 
 *  */ 

%token ID  
%token IDCOLON  /* identifier (but not literal) followed by colon */   
%token NUM  /* [0-9]+ */ 

	/* reserved words:  %type => TYPE,  %left => LEFT, etc.  */  
%token LEFT RIGHT NONASSOC TOKEN PREC TYPE START UNION 
%token MARK   /* the %% mark */  
%token LCURL  /* the %{ mark */  

	/* tokens of (yox - yacc) */ 
%token STRUCT UNIONC ATTRIBUTES LBRACE RBRACE COLCOL COLCOLCOL ATAT 
%token CHAR SHORT INT LONG SIGNED UNSIGNED FLOAT DOUBLE VOID 
%token EOGF RETURN  

%start spec   

%{ 
#include <stdio.h> 
#include "globalDecls.h" 

char *inFileStr;  

FILE *yoxInG; 
char *yoxInFileStrG; 

FILE *yoxInL; 
char *yoxInFileStrL; 

FILE *yoxOutG; 
char *yoxOutFileStrG = "yox.out.y"; 

FILE *yoxOutL; 
char *yoxOutFileStrL = "yox.out.l"; 

FILE *temp1Out; 
FILE *temp2Out; 
FILE *temp3Out; 
FILE *temp4Out; 
FILE *temp5Out; 
FILE *temp6Out; 
FILE *temp7Out; 
FILE *temp8Out; 

extern void bufferAnAttrbID();
extern void prepareDataStructures1(); 
extern int checkAttrbsSynOrInh(); 
extern int testPruneCond1(); 
extern void printIntNodeGenInvocation(); 
extern void conveyLocalDepGraphInfo(); 
extern int memberDepend(); 
extern void processAdepSpec(); 
extern void prepareDataStructures2(); 
extern void organizeTables(); 
extern void BEGINpc(); 
extern void initLDG(); 
extern void printSASheader(); 
extern void printSAStrailer(); 
extern void compilerTextCopy5(); 

extern char *startSymLexeme; 
extern int prodBufferPointer2; 
extern int bufPosInProd,bufAttrbNum; 
extern int prodNumSeq; 
extern FILE *yyin; 
extern int yylineno; 
extern int line,nLbraces;
extern char *IDbuffer; 
extern char *gsBuffer; 
 
char *inFileStr;  



#define errMsgU \
        "usage: yox <file1> <file2> [<file3> <file4>] [-<options>]\n"

#define erasf(f) {char dummy[64];                      \
                  strcpy(dummy,"rm ");                 \
                  system(strcat(dummy,(f)));           \
                 } 
#define appnd(f1,f2) {char buff[512];                                  \
                      int size;                                        \
                      while (size = fread(buff,sizeof(*buff),512,f2))  \
                            fwrite(buff,sizeof(*buff),size,f1);        \
                     }  
                         
extern int yylex(void);

#if YYBTYACC && !YYBYACC
extern void yyerror(const char *, ...);
#else
extern void yyerror(const char *);
#endif
%} 

%% 
spec 	: 	specG 	EOGF 
		{organizeTables(); 
                 compilerTextCopy5();  
		} 
		specL 
	; 

specG	:	defs 	MARK 	
		{printSASheader();} 
		rules  	
		{printSAStrailer(); 
		} 
		root_attrb_ref_section 
		{fprintf(temp1Out,"} /* yyyExecuteRRsection */ \n"); 
   		}  
		tail     
		{flushLAbuffer(LA1,outG);} 
	; 

tail 	:        
	|  	{BEGINpc(pcTT);}  MARK  
	;  
 
root_attrb_ref_section  
	: 	
	|	ATAT 
		{prodBufferPointer2 = 0;   
                 putSymbolInProdBuffer2(gSymLookup(startSymLexeme));
 		}
		root_attrb_ref_seq 
	; 

root_attrb_ref_seq	
	: 
	|	root_attrb_ref_seq ID 
		{genImmCrefForAttrbRef(bufPosInProd,bufAttrbNum,1,temp1Out);}  
	; 
	
defs	:	
	|	defs def 
	; 

def 	:	START ID {installStartSym(startSymLexeme);}  
	|	UNION {line = yylineno;}      
 	|	LCURL {BEGINpc(pcCC); line = yylineno;}    
	|	TOKEN tag nlistT   
	|	rword tag nlist   
	|	ATTRIBUTES 
		{initForAttrbDeclList();} 
		'{' attribute_decl_list '}' 
                {afterAttrbDeclList();} 
              	grammar_symbol_list 
	; 

rword	: 	LEFT 
	| 	RIGHT 
	|	NONASSOC
	|	TYPE  
	; 
	
tag 	:	 
	|	'<'  ID  '>'  
	; 

nlist 	: 	nmno 
	| 	nlist nmno 
	|	nlist  ','  nmno 
	; 

nmno 	:	ID   
	|	ID NUM 
	; 

nlistT 	: 	nmnoT 
	| 	nlistT nmnoT 
	|	nlistT  ','  nmnoT 
	; 

nmnoT 	:	ID {installGsymAsToken(IDbuffer);} 
                /* yacc will catch the error later */     
	|	NUM 
	; 

attribute_decl_list  
	: 
	| 	attribute_decl_list attribute_decl   
	; 

attribute_decl  
	:	type_specifier id_seq stars ID 
		{bufferAnAttrbID(IDbuffer);} 
		field_length_spec 
		';' 
	|	VOID id_seq2 ID  
		{bufferAnAttrbID(IDbuffer);} ';' 
	; 

type_specifier
	: STRUCT ID   
	| UNIONC ID 
	| ID  	
	| type_keyword_list type_keyword  
	; 

type_keyword_list 
	: 
	|	type_keyword_list type_keyword 
	; 

type_keyword 
	: CHAR | SHORT | INT | LONG | FLOAT | DOUBLE | SIGNED | UNSIGNED 
	;

id_seq 	:	
	|	id_seq stars ID {bufferAnAttrbID(IDbuffer);} ','  
	; 

id_seq2	:	
	|	id_seq2 ID {bufferAnAttrbID(IDbuffer);} ','  
	; 

stars 	: 
	| 	stars '*'  
	;

field_length_spec 
	:	
	|	':' NUM 
	;  
	
grammar_symbol_list 
	:	
	|	grammar_symbol_list ID 
		{installGsymAfterAttrbDeclList(IDbuffer);}  
	;

rules 	:	IDCOLON 
		{prodBufferPointer2 = 0; incProdNumSeq(); 
                 putSymbolInProdBuffer2(installGsymAsNontermIfNew(IDbuffer)); 
                } 
		rbody attrb_def_section  
	|	rules rule  
	; 

rule 	:	IDCOLON  
		{prodBufferPointer2 = 0; incProdNumSeq();  
                 putSymbolInProdBuffer2(installGsymAsNontermIfNew(IDbuffer)); 
                } 
 		rbody attrb_def_section  
	| 	'|'  
		{prodBufferPointer2 = 1; incProdNumSeq();  
		} 
		rbody attrb_def_section  
	; 

rbody 	: 
	|	rbody ID 
		{if (IDbuffer[0] != '\'')  
                    putSymbolInProdBuffer2(installGsymAsNontermIfNew(IDbuffer));
                    else 
                    putSymbolInProdBuffer2(installGsymAsToken(IDbuffer));  
                }  
	|	rbody PREC ID   
	|	rbody act  
	; 

act  	: 	{BEGINpc(pcAA); line = yylineno; nLbraces = 1;} 
		'{' 
		'}'         
	; 

attrb_def_section 
	: 	{initLDG();} 
		a_d_s_body 
		{checkAttrbsSynOrInh(); 
                 testPruneCond1();  
		 fputc('{',yoxOutG);  
		 printIntNodeGenInvocation();    
		 ldgTopSort(yoxOutG);  
		 conveyLocalDepGraphInfo();  
		 fputc('}',yoxOutG);   
   		 flushLAbuffer(LA1,outG);  
		}   
	|	attrb_def_section ';' 
	; 

a_d_s_body 
	: 	
	|	LBRACE attrb_def_list RBRACE { }  
	;

attrb_def_list 
	:	
	|	attrb_def_list attrb_def {processAdepSpec();}  
	; 

attrb_def:	COLCOL ID 
		{memberDepend(bufPosInProd,bufAttrbNum,1,1); 
		} 
		im_dependee_ref_seq 
		'\n' 

	|	dependent_name_seq COLCOLCOL mm_dependee_ref_seq '\n'

	|	dependent_name_seq ':' dependee_name_seq ';' ref_seq '\n'  

	; 

im_dependee_ref_seq  
	:	
	|	im_dependee_ref_seq ID 
		{if (!memberDepend(bufPosInProd,bufAttrbNum,1,0))
		    memberDepend(bufPosInProd,bufAttrbNum,0,1);
		    else 
		    yyerror("implicit dependent depends on itself\n"); 
		} 
	;
 
mm_dependee_ref_seq  
	:	
	|	mm_dependee_ref_seq ID 
		{if (!memberDepend(bufPosInProd,bufAttrbNum,1,0))
		    memberDepend(bufPosInProd,bufAttrbNum,0,1);
		} 
	;
 
dependent_name_seq  
	:	ID 	
		{memberDepend(bufPosInProd,bufAttrbNum,1,1);} 
	|	dependent_name_seq ID 
		{if (memberDepend(bufPosInProd,bufAttrbNum,1,1)) 
                    yyerror("duplicate dependent\n"); 
		} 
	; 
 
dependee_name_seq  
	:	
	|	dependee_name_seq ID 
		{if (memberDepend(bufPosInProd,bufAttrbNum,1,0)) 
                    yyerror("attribute depends immediately on itself\n"); 
		    else 
		    {if (memberDepend(bufPosInProd,bufAttrbNum,0,1)) 
                        yyerror("duplicate dependee\n"); 
                    } 
		} 
	; 
 
ref_seq : 
	|	ref_seq ID  
		{if (!memberDepend(bufPosInProd,bufAttrbNum,0,0) &&  
		     !memberDepend(bufPosInProd,bufAttrbNum,1,0) 
		    ) 
    yyerror("in explicit mode, referred to attribute not named explicitly\n"); 
		}
	; 

specL 	:	MARK Lrules   
	|	MARK Lrules MARK  
	; 

Lrules 	: 	
	|	Lrules
		RETURN parenthesized_ID ';'    
		attrb_def_sectionL 
		{checkAttrbsSynOrInh();} 
	;

parenthesized_ID
	:	ID 
		{prodBufferPointer2 = 0;   
                 putSymbolInProdBuffer2(gSymLookup(IDbuffer));
		 installLeafRefCountInitList();  
	 	 initLDG();
    		} 
	|	'(' parenthesized_ID ')' 
	; 
 
attrb_def_sectionL 
	:
	| 	LBRACE 
		ref_seqL 
		RBRACE 
	; 
	
ref_seqL  
	:	
	|	ref_seqL ID 
		{if (memberDepend(bufPosInProd,bufAttrbNum,1,1)) 
                    yyerror("attribute multiply defined\n"); 
		 genImmCrefForAttrbRef(bufPosInProd,bufAttrbNum,0,yoxOutL);  
                 processAdepSpec(); 
		} 
	; 
 
%% 


main(argc,argv) 
  int argc; 
  char *argv[];  
{BEGINpc(pcYD); 
 if ((argc < 3) || (argc == 4)) 
    {fprintf(stderr,errMsgU); exit(1);} 
 yoxInFileStrG = argv[1]; 
 inFileStr = yoxInFileStrG; 
 yoxInFileStrL = argv[2];  
 if (argc == 5) {yoxOutFileStrG = argv[3]; yoxOutFileStrL = argv[4];}   
 yoxInG = fopen(yoxInFileStrG,"r"); 
 yyin = yoxInG; 
 yoxInL = fopen(yoxInFileStrL,"r");  
 yoxOutG = fopen(yoxOutFileStrG,"w");  
 yoxOutL = fopen(yoxOutFileStrL,"w");  
 temp1Out=fopen(temp1FileID,"w"); 
 temp2Out=fopen(temp2FileID,"w"); 
 temp3Out=fopen(temp3FileID,"w"); 
 temp4Out=fopen(temp4FileID,"w"); 
 temp5Out=fopen(temp5FileID,"w"); 
 temp6Out=fopen(temp6FileID,"w"); 
 temp7Out=fopen(temp7FileID,"w"); 
 temp8Out=fopen(temp8FileID,"w"); 
 prepareDataStructures1(); 
 prepareDataStructures2(); 
 yyparse(); 
 fclose(yoxInG);   
 fclose(yoxInL);   
 fclose(yoxOutG);   
 fclose(yoxOutL);   
 fclose(temp1Out); 
 fclose(temp2Out); 
 fclose(temp3Out); 
 fclose(temp4Out); 
 fclose(temp5Out); 
 fclose(temp6Out); 
 fclose(temp7Out); 
 fclose(temp8Out); 
 erasf(temp1FileID);    
 erasf(temp2FileID);    
 erasf(temp3FileID);    
 erasf(temp4FileID);    
 erasf(temp5FileID);    
 erasf(temp6FileID);    
 erasf(temp7FileID);    
 erasf(temp8FileID);    
 exit(0); 
}  
 
