%token ZERO ONE DOT   

%start num   

@attributes {float value;}                    num 
@attributes {float value; int scale,length;}  bitlist 
@attributes {float value; int scale;}         bit 

%{
#include <stdio.h>

#if YYBTYACC && !YYBYACC
/* the `btyacc' 3.0 skeleton omits the following */
#include "parser.h"
#endif

float numValue;

extern int yylex(void);

#if YYBTYACC && !YYBYACC
void yyerror(const char *, ...);
#else
void yyerror(const char *);
#endif
%}

%%
num     :       bitlist              
                @{ @i numValue = @num.value@ = @bitlist.0.value@;
                   @i @bitlist.scale@ = 0; 
                @} /* value is synthesized for num. */
                   /* scale is inherited for bitlist. */
                   /* value and length are synthesized for bitlist. */ 

        |       bitlist DOT     bitlist  
                @{ @i numValue = @num.value@ = 
                         @bitlist.0.value@ + @bitlist.1.value@; 
                   @i @bitlist.0.scale@ = 0;
                   @i @bitlist.1.scale@ = - @bitlist.1.length@;
                @}        
        ;

bitlist :      bit 
               @{ @i @bitlist.value@ = @bit.value@; 
                  @i @bit.scale@ = @bitlist.scale@;
                  @i @bitlist.length@ = 1; 
               @} /* length is synthesized for bit. */
                  /* scale is inherited for bit.    */

        |       bitlist bit              
                @{ @i @bitlist.0.value@ = @bitlist.1.value@ + @bit.value@; 
                   @i @bit.scale@ = @bitlist.0.scale@;
                   @i @bitlist.1.scale@ = @bitlist.0.scale@ + 1; 
                   @i @bitlist.0.length@ = @bitlist.1.length@ + 1; 
                @}
        ;

bit     :       ZERO
                @{ @i @bit.value@ = 0;
                @} 

        |       ONE
                @{ @i @bit.value@ = twoToThe(@bit.scale@); 
                @}
        ;

%% 
#if YYBTYACC && !YYBYACC
void yyerror(const char *s, ...)
{extern int yylineno;
 fprintf(stderr,"Near line %d: %s\n",yylineno,s); 
 yyyabort(); 
}  
#else  
void yyerror(const char *s)
{fprintf(stderr,"%s\n",s);
 yyyabort(); 
}
#endif

#ifndef YYMSTA
int yyparse(void);
#endif

int main() 
  {if (!(yyparse())) 
      fprintf(stderr, "%30.15f\n",numValue); 
  } 



float twoToThe(int in)         /* returns 2 raised to the power in */  
  {if (in < 0) return (1.0 / twoToThe(-in)); 
   if (in == 0) return 1.0; 
      else return (2.0 * twoToThe(in - 1));
  } 

