#include "config.h"

#if HAVE_STRERROR
#include <cstring>
#endif

#include <cstdio>

#include "parser.hh"
#include "driver.hh"

driver::driver ()
  : trace_parsing (false), trace_scanning (false)
{
  variables["one"] = 1;
  variables["two"] = 2;
}

int
driver::parse (const std::string& f)
{
  file = f;
  scan_begin ();
  yy::parser parse (*this);
  parse.set_debug_level (trace_parsing);
  int res = parse ();
  scan_end ();
  return res;
}
