#ifndef DRIVER_HH
#define DRIVER_HH

#include <string>
#include <map>

class yoxLexer;

// conducts the scanning and parsing
class driver
{
public:
  driver ();

  std::map<std::string, int> variables;

  int result;

  // Run the parser on file F.  Return 0 on success.
  int parse (const std::string& f);

  // The name of the file being parsed.
  std::string file;

  // Whether to generate parser debug traces.
  bool trace_parsing;

  // Handling the scanner.
  void scan_begin ();
  void scan_end ();

  // Whether to generate scanner debug traces.
  bool trace_scanning;

#if defined (USE_FLEXCXX)
  // `yylex()' for the parser's use
  int yylex (YYSTYPE* yylval_param, YYLTYPE* yylloc_param, driver& drv);

private:
  // The scanner
  yoxLexer* theScanner;
#endif
};

#endif // !DRIVER_HH
