#ifndef DRIVER_H
#define DRIVER_H

#include <string>
#include <map>

class yyFlexLexer;

class driver
{
public:
  driver ();

  std::map<std::string, int> variables;

  int result;

  // Run the parser on file F.  Return 0 on success.
  int parse (const std::string& f);

  // The name of the file being parsed.
  std::string file;

  // Whether to generate parser debug traces.
  bool trace_parsing;

#if defined (USE_FLEXCXX)
  // The scanner
  yyFlexLexer* theScanner;
#endif

  // Handling the scanner.
  void scan_begin ();
  void scan_end ();

  // Whether to generate scanner debug traces.
  bool trace_scanning;
};

extern driver drv;

#endif // ! DRIVER_H
