#if defined (__cplusplus)
#include <cstdbool>
#else
#include <stdbool.h>
#endif

struct enumList;
struct typeSpec;
struct symbolTableItem {
    char            *sym;
    bool             isConstVal;
    int              constVal;
    bool             isEnumLit;
    struct enumList *whichEnum;
    bool             isTypeName;
    struct typeSpec *whichType;
};
typedef struct symbolTableItem *symbol;
typedef struct symbolTableItem *symTable;

struct enumList {
    symbol           enumLit;
    int              constVal;
    struct enumList *next;
};
typedef struct enumList *enumListT;

struct subRange {
    int              start;
    int              end;
};
typedef struct subRange *subRangeT;

enum typeSpecTag {enumT, rangeT};
struct typeSpec {
    enum typeSpecTag tag;
    union {
        struct enumList enumType;
        struct subRange rangeType;
    }           type;
};
typedef struct typeSpec *typeSpecT;
