%locations

%left LO '+' '-'
%left HI '*' '/' '%'
%nonassoc UNARY

%union {
    long val;
}
%union {
    long (*binop)(long, long);
}
%union {
    long (*unop)(long);
}

%start input

%token NUMBER

%type<binop> op1 op2
%type<unop> unary
%type<val> expr NUMBER

@attributes {long val;} input expr NUMBER
@attributes {long (*binop)(long, long);} op1 op2
@attributes {long (*unop)(long);} unary

%{ 
long exprVal;
%} 

%%

input	:	/*empty*/
		@{ @i exprVal = @input.val@ = 0; @}
	|	input expr '\n'
		[{if (false) {if (true) {YYVALID;} else {;}} else {YYVALID;}}
		  /* nested compound statements work in `btyacc'/`byacc' []-actions */]
		{ fprintf(stderr, "yacc semval = %ld\n", $2); }
		@{ @decorate
		   @m input.val;
		      {exprVal = @input.val@ = @expr.val@;
		       fprintf(stderr, "  ox semval = %ld\n", exprVal);} @}
	|	input '\n' [ YYVALID; ]
		@{ @i exprVal = @input.val@ = 0; @}
	|	input error '\n' { YYERROR_CALL("Recovered from syntax error"); yyerrok; }
		@{ @i exprVal = @input.val@ = 0; @}
	;

expr	:	expr op1 expr %prec LO { $$ = $2($1, $3); }
		@{ @i @expr.0.val@ = @op1.binop@(@expr.1.val@,@expr.2.val@); @}
	|	expr op2 expr %prec HI { $$ = $2($1, $3); } 
		@{ @i @expr.0.val@ = @op2.binop@(@expr.1.val@,@expr.2.val@); @}
	|	unary expr /* %prec UNARY */ { $$ = $1($2); } %prec UNARY
		@{ @i @expr.0.val@ = @unary.unop@(@expr.1.val@); @}
	|	'(' expr ')' { $$ = $2; }
		@{ @i @expr.0.val@ = @expr.1.val@; @}
	|	NUMBER { $$ = $1; }
		@{ @i @expr.0.val@ = @NUMBER.val@; @}
	;

op1	:	'+' { $$ = add; }
		@{ @i @op1.binop@ = add; @}
	|	'-' { $$ = sub; }
		@{ @i @op1.binop@ = sub; @}
	;

op2	:	'*' { $$ = mul; }
		@{ @i @op2.binop@ = mul; @}
	|	'/' { $$ = divide; }
		@{ @i @op2.binop@ = divide; @}
	|	'%' { $$ = rem; }
		@{ @i @op2.binop@ = rem; @}
	;

unary	:	'+' { $$ = pos; }
		@{ @i @unary.unop@ = pos; @}
	|	'-'   { $$ = neg; }
		@{ @i @unary.unop@ = neg; @}
	;

%%

extern int yylex(void);

void YYERROR_DECL() {
  fprintf(stderr, "%s @ [%d:%d,%d:%d]\n", s, loc->first_line, loc->first_column,
					  loc->last_line , loc->last_column);
}

long add(long a, long b) { return a+b; }
long sub(long a, long b) { return a-b; }
long mul(long a, long b) { return a*b; }
long divide(long a, long b) { return a/b; }
long rem(long a, long b) { return a%b; }
long pos(long a) { return a; }
long neg(long a) { return -a; }
