/* Y-file for translation of infix expressions to prefix and postfix */
%token ID CONST  
%start s    
%left '+' '-'
%left '*' '/'
%nonassoc '*'						/* byacc error: precedence redeclared */

@attributes {char *lexeme;} ID CONST 
@traversal @preorder LRpre
@traversal LRpost

%{ 
#include "semtypes.h" 
#include <stdio.h>

extern int yylex(void);
extern void yyerror(const char *);
%} 

%%
s       :       expr
                @{ @LRpost fprintf(stderr,"\n"); 
                   @LRpost @revorder (1) {fprintf(stderr,"postfix:  ")	/* C error: missing ; */}
                   @LRpre  @revorder (1) fprintf(stderr,"\n"); 
                   @LRpre  fprintf(stderr,"prefix:   ");
                @}
	;
expr    :       expr    '*'     expr
                @{ @LRpost fprintf(stderr," * "); 
                   @LRpre  fprintf(stderr," * "); 
                @}
        |       expr    '+'     expr
                @{ @LRpre  fprintf(stderr," + "); 
                   @LRpost fprintf(stderr," + "); 
                @}
        |       expr    '/'     expr
                @{ @LRpost fprintf(stderr," / "); 
                   @LRpre  fprintf(stderr," / "); 
                @}
        |       expr    '-'     expr
                @{ @LRpost fprintf(stderr," - "); 
                   @LRpre  fprintf(stderr," - "); 
                @}
        |       '('     expr    ')'
        |       ID
                @{ @LRpost fprintf(stderr," %s ",@ID.lexeme@); 
                   @LRpre  fprintf(stderr," %s ",@ID.lexeme@); 
                @}
        |       CONST
                @{ @LRpost fprintf(stderr," %s ",@CONST.lexeme@); 
                   @LRpre  fprintf(stderr," %s ",@CONST.lexeme@); 
                @}
        ;
%% 

int yyparse(void);

int main() 
  {yyparse(); 
  } 



