/* $Id: gppl_glob.h 2098 2021-02-16 02:47:30Z teshields $ */ 

#if defined (__cplusplus)
#include <cstdio>
#include <cstdlib>
#include <cstring>
#else
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#endif

#define DONTCARE 0 

#define ceiling(num,inc) (((inc) * ((num)/(inc))) + (((num)%(inc))?(inc):0)) 

#define max(t1,t2) (((t1)>(t2))?(t1):(t2))

#define spaceSetup(string,type,name,size,minSize,after,stock) \
if ((size) < (minSize)) {fprintf(stderr,\
"allocation request for %s space too small.\n",string);\
exit(-1);}\
if (((name) = (type *) malloc((size) * sizeof(type)))  \
    == \
    ((type *) NULL) \
   )   \
{fprintf(stderr,"malloc error in %s space allocation.\n",string);exit(-1);}\
(stock) = (name) + 1; \
(after) = ((name) + (size)); 

typedef unsigned short lineNumType;
typedef unsigned short labelType;
typedef unsigned short levelType;
typedef short regNumType;

enum stgClass {VARIABLEC,VALPARAMC,REFPARAMC};
enum symType  {INTT,FLOATT,BOOLT,VOIDT,ERRT};  
enum mapType  {ARITHM,LOGM}; 
enum pred     {False,True};

extern enum pred doCodeGen;

extern long stgSize(enum symType,long); 
extern void handleSemError(void); 
extern void yyyabort(void); 

union num {int i; 
           float f; 
           int b; 
          };

struct dim {long size;
            long scale;
            struct dim *next;
           };

struct sym {
            /* members used for all kinds of symbols */
            char *id; 	
            lineNumType line; 
            enum symType type; 
            levelType level;
            struct sym *next; 

            /* members used only for storage symbols */
            enum stgClass Class; 
            long addr;
            long size;
            struct dim *dimList;

            /* members used only for function symbols */
            long paramsSize;
            labelType label; 
            struct sym *paramLoc;
           }; 

struct env {struct sym *funcSym;
            struct sym *varLoc;
            struct sym *funcLoc; 
            levelType level; 
            short nRegs;
            labelType exitLabel;
            long varsSize;
            struct env *outerEnv; 
           }; 

extern struct dim *dimListSpace; 
#define lambdaDim dimListSpace 

extern struct sym *symSpace; 
#define lambdaSym symSpace 

extern struct env *envSpace; 
#define lambdaEnv envSpace 
