#ifndef __lit_h
#define __lit_h

/* Literal Table: name & value for each uniquely spelled literal */

#include "types.h"

typedef enum { undef_lit=0, int_lit=1, real_lit=2, bool_lit=3, bits_lit=4, string_lit=5 } lit_kind_type;

typedef struct _lit_defn {
  lit_kind_type kind;
/*
  union { long long int integral_value;
	  long double real_value;
	  bool boolean_value;
	  long long unsigned bits_value;
	  string string_value; } value; */
  string C_literal;
} *lit_defn;

lit_defn add_lit ( string );
lit_defn in_lit_set ( string );

string g_lit_name ( lit_defn );

void s_int_lit ( lit_defn, char * );
void s_real_lit ( lit_defn, char * );
void s_bool_lit ( lit_defn, char * );
void s_bits_lit ( lit_defn, char * );
void s_string_lit ( lit_defn, char * );

void dump_lit ( void );

#endif
