/* $Id: glob.h 650 2018-01-17 22:38:09Z Tom Shields $ */ 

/* The information in this file is the intellectual property of 
 * Kurt M. Bischoff.  It may not be used, copied, or transferred 
 * without permission from the author. 
 *
 * Copyright (c) 1992, Kurt M. Bischoff.  All rights reserved.
 *
 * Beta Test Release--not for general distribution.
 */ 

#define DONTCARE          0 

#define augmentationNonterminal 0  
#define augNstr "yyyAugNonterm" 
#define augTstr "yyyAugTerm"  

extern void ywarning(const char *);
extern void yerror(const char *); 

#define temp1FileID "@temp1.~tab~.c" 
#define temp2FileID "@temp2.~tab~.c" 
#define temp3FileID "@temp3.~tab~.c" 
#define temp4FileID "@temp4.~tab~.c" 
#define temp5FileID "@temp5.~tab~.c" 
#define temp6FileID "@temp6.~tab~.c" 
#define temp7FileID "@temp7.~tab~.c" 
#define temp8FileID "@temp8.~tab~.c" 
#define tempTravFileID "@temp.~trav~" 
#define tempTrashFileID "@temp.~trash~"

extern FILE *temp1Out; 
extern FILE *tempTravOut; 
extern FILE *tempTrashOut; 
 
#define outG          1 
#define outL          2  
#define outT1         3  
#define outGandL      4 
#define LA1          11   
#define LA2          12   
#define rsB          21 
#define outMB        30
#define outTrv       40
#define nowhere      45


typedef unsigned short prodNumType; 

enum instRefType {imm,decor,trav};
enum ENTorEE {ENT,EE};  /* dependent or dependee */

struct attrbAttrbs {unsigned int IorSknown : 1; 
                    unsigned int InotS     : 1; 
                   };  
                       

typedef struct gSym  
        {short symNum; 
         char *lexeme; 
         char **attrbID;  
         unsigned char nAttrbs; 
         int typeNum;  
         int lineOfFirstDef;  
         char *fileOfFirstDef; 
         struct attrbAttrbs *aaList;  
        } 
        *gSymType; 

 
struct pb2 {char *lexeme; 
            int gSymTabInd; 
           };  
extern struct pb2 *prodBuffer2; 
extern int prodBufferPointer2; 

extern char *startSymLexeme; 
extern char *inFileStr; 

struct attrbOccr {short symPos,attrbNum;
                 }; 


/* error messages */  
#define dupStart "start symbol defined more than once" 
#define InvLitChar "unknown or forbidden literal character"  
#define tokOnLeft "token seen on left hand side of a rule" 

extern int removeOutput; 
