/* $Id: scan.h 2625 2022-08-02 02:07:14Z teshields $ */ 

/* The information in this file is the intellectual property of 
 * Kurt M. Bischoff.  It may not be used, copied, or transferred 
 * without permission from the author. 
 *
 * Copyright (c) 1992, Kurt M. Bischoff.  All rights reserved.
 *
 * Beta Test Release--not for general distribution.
 */ 

#include "parser.h" 

#if YYBTYACC && !YYBYACC
extern void yyerror(const char *, ...);
#else
extern void yyerror(const char *);
#endif

extern void scanInit1(void); 
extern void scanInit2(void); 
extern void scanInit3(void); 
extern void scanInit4(void); 

extern int yy1ScnState(void);
extern int yy2ScnState(void);
extern int yy3ScnState(void);

#ifdef USING_REFLEX
extern int yy1wrap(void);
extern int yy2wrap(void);
extern int yy3wrap(void);
extern int yy4wrap(void);
#endif

extern int yy1lex(void);
extern int yy2lex(void);
extern int yy3lex(void);
extern int yy4lex(void);

extern char inputFromMacro(void);

extern char *IDbuffer; 
extern char *gsBuffer; 
extern char *dumNodeSym; 
extern int alreadyAugmented; 
extern int nLbraces; 
extern int nLparens; 
extern int whichScanner; 
extern int line; 

extern int *plineno; 
extern char *ptext; 

#if defined (USING_REFLEX)
extern int yywrap(void);
#endif
extern int yylex(void);
extern char *stringLookup(char *,int,int);  
extern char *getFirstTextOfCC(char *); 
extern void appendToOutFile(FILE *,const char *,FILE *); 
extern void compilerTextCopy5(void); 
extern void yerror(const char *); 
extern void ywarning(const char *); 
extern void fatal(const char *);    
extern void rmTempFiles(void);

extern struct gSym *gSymTable; 
extern int bufPosInProd,bufAttrbNum;  
extern int hasYaccPvarRefGlob; 

extern FILE *yoxInG; 
extern FILE *yoxOutG; 
extern FILE *yoxOutH; 
extern FILE *temp1Out; 
extern FILE *yoxInL; 

extern int eatCom; 
extern int eatStr;

/* must be consistent with lex.yy.c's "BEGIN" */  

extern void charOut(char,int); 
extern void stringOut(char *,int); 
extern void flushLAbuffer(int,int); 
extern void eatCommentAndEcho(int,int); 
extern void eatStringAndEcho(int); 
extern void afterAllAttrbDecls(void); 
extern void transAttrbNameToNumPair(void); 
extern void scanAttrbName(char *,int); 
extern void putIDinMacroDefBody(char *); 

