/* $Id: trav.h 689 2018-01-19 23:56:34Z Tom Shields $ */

/* The information in this file is the intellectual property of 
 * Kurt M. Bischoff.  It may not be used, copied, or transferred 
 * without permission from the author. 
 *
 * Copyright (c) 1992, Kurt M. Bischoff.  All rights reserved.
 *
 * Beta Test Release--not for general distribution.

*/ 
struct travSegBuf {long orderRevCondStartPtr;
                   long orderRevCondStopPtr;
                   long actionStartPtr;
                   long actionStopPtr;
                   struct travSegBuf *next;
                  };

struct trav {const char *id;
             unsigned int RL   : 1;
             unsigned int LR   : 1;
             unsigned int PRE  : 1;
             unsigned int POST : 1;
             unsigned int DA   : 1;
             long dirRevCondStartPtr;
             long dirRevCondStopPtr;
             int nActions;
             struct travSegBuf *TSBlist;
            };

extern void newTrav(const char *);
extern void clearTravBuf(void);
extern int travLookup(char *);
extern void printTravCode(void);
extern void outputTravCodePerProd(void);
extern void wrapUpTravAction(void);

extern int maxNtravs;
extern struct trav *travArr;
extern struct trav travBuf;
extern int travNumSeq;

extern int maxNtravSegBufs;
extern struct travSegBuf *travSegBufArr,*lambdaTSB;
extern int travSegBufAvail;

extern int currentTrav;


