/* To demonstrate the use of an attribute grammar for the printing of parse
 *  trees of a simple expression grammar.
 */

%{
#if defined (__cplusplus)
#include <cstdio>
#include <cstring>
#else /* !defined (__cplusplus) */
#include <stdio.h>
#if defined (__sun) && defined (__SVR4)
#include <strings.h>
#else
#include <string.h>
#endif
#endif /* !defined (__cplusplus) */

#include "pt.h"

#if YYBTYACC && !YYBYACC
/* the `btyacc' 3.0 skeleton omits the following */
#include "parser.h"
#endif

#define max(i1,i2) (((i1) >= (i2)) ? (i1) : (i2))

extern int yylex(void);

#if YYBTYACC && !YYBYACC
void yyerror(const char *, ...);
#else
void yyerror(const char *);
#endif
%}

%token CONST

%start s

@attributes {
             short line,column; imageDesc imD;
             short hanger; @void print; int val;
             short height,width;
	    } e

@attributes {
             short line,column; imageDesc imD;
             short height,width,hanger; @void print; int val;
	    } f

@attributes {int val;} CONST

@attributes {
             @void print;
             imageDesc imD;
             short column;
             short hanger;
             int val;
             short width;
             short line;
             short height;
	    } t

@attributes {short height,width,hanger; @void print; int val;
             short line,column; imageDesc imD;
	    } s



%%
s	:
	@{  @e s.line:; {}
	    @e s.column:; {}
	    @e s.height:; {}
	    @e s.width:; {}
	    @e s.hanger:; {}
            @e s.imD:; {}
            @e s.print:; {}
            @e s.val:; {}
	@}
	|	s	e    	'\n' 	
	 @{ @decorate
            @i @s.line@ = 0;
	    @i @s.column@ = 0;
	    @i @s.height@ = @e.height@ + 2;
	    @i @s.width@ = @e.width@;
	    @i @s.hanger@ = @e.hanger@;
            @i @s.val@ = @e.val@;
	    @e s.imD: s.height s.width ; {
              int i;
              @s.imD@.h = @s.height@;
              @s.imD@.w = @s.width@ + 1;
	      if ((@s.imD@.im = (char *)malloc(@s.imD@.w * @s.imD@.h))
		  ==
		  ((char *)NULL)
		 )
		 {fprintf(stderr,"error in mallocing image storage\n");
	 	  exit(-1);
		 }
	      for (i=(@s.imD@.h*@s.imD@.w) - 1; i>=0;i--)
                (@s.imD@.im)[i] = ' ';
	      for (i=@s.imD@.h;i>0;i--)
                (@s.imD@.im)[i * @s.imD@.w - 1] = '\n';
              }
            @e s.print : e.print s.imD s.hanger s.val; {
	      (@s.imD@.im)[@s.hanger@] = 's';
	      (@s.imD@.im)[@s.imD@.w + @s.hanger@] = '|';
              showPT(@s.imD@);
/*              fprintf(stderr,"\n%d\n\n",@s.val@);  */
              fprintf(stderr,"\n\n\n");
		       }
	    @i @e.line@ = @s.line@ + 2;
	    @i @e.column@ = @s.column@;
	    @i @e.imD@ = @s.imD@;
	@}
	;

e	:	e 	'+'	t{} 	
	 @{ @i @e.1.line@ = @e.0.line@ + 2;
            @i @e.1.column@ = @e.0.column@;
	    @i @t.line@ = @e.0.line@ + 2;
            @i @t.column@ = @e.1.column@ + @e.1.width@ + 3;
	    @i @e.0.height@ = max(@e.1.height@,@t.height@) + 2;
	    @i @e.0.width@ = @e.1.width@ + 3 + @t.width@;
            @i @e.0.hanger@ = (@e.1.hanger@ + @e.1.width@ +3+ @t.hanger@) /2;
            @i @e.val@ = @e.1.val@ + @t.val@;
	    @e e.0.print: e.0.line e.0.column e.0.hanger
		       e.1.hanger e.1.width
		       t.hanger
		       e.imD e.1.print t.print
		     ;                    {
              char *temp;
 	      temp = @e.imD@.im + (@e.imD@.w*@e.0.line@)+@e.0.column@;
 	      *(temp + @e.0.hanger@) = 'e';
 	      temp += @e.imD@.w;
	      *(temp + (@e.0.hanger@+@e.1.hanger@)/2) = '/';
 	      *(temp + @e.0.hanger@) = '|';
	      *(temp+(@e.0.hanger@+@e.1.width@+3+@t.hanger@)/2) = '\\';            					
 	      *(temp + @e.imD@.w + @e.0.hanger@) = '+';
		     }
	      @i @e.1.imD@ = @e.imD@;
	      @i @t.imD@ = @e.imD@;
        @}

	|	t  {}
	 @{ @i @e.height@ = @t.height@ + 2;
	    @i @e.width@ = @t.width@;
	    @i @e.hanger@ = @t.hanger@;
	    @i @t.line@ = @e.line@ + 2;
	    @i @t.column@ = @e.column@;
            @i @e.val@ = @t.val@;
	    @e e.print: e.line e.column e.hanger
		     e.imD t.print
		   ;        {
	    *(@e.imD@.im+(@e.imD@.w*@e.line@)+@e.column@+@e.hanger@) = 'e';
	    *(@e.imD@.im+(@e.imD@.w*(@e.line@+1))+@e.column@+@e.hanger@) = '|';
			 }
	    @i @t.imD@ = @e.imD@ ;
        @}
	;

t	:	t	'*'	f{} 	
	 @{ @i @t.1.line@ = @t.0.line@ + 2;
            @i @t.1.column@ = @t.0.column@;
	    @i @f.line@ = @t.0.line@ + 2;
            @i @f.column@ = @t.1.column@ + @t.1.width@ + 3;
	    @i @t.0.height@ = max(@t.1.height@,@f.height@) + 2;
	    @i @t.0.width@ = @t.1.width@ + 3 + @f.width@;
            @i @t.0.hanger@ = (@t.1.hanger@ + @t.1.width@ +3+ @f.hanger@) /2;
            @i @t.val@ = @t.1.val@ * @f.val@;
	    @e t.0.print: t.0.line t.0.column t.0.hanger
		       t.1.hanger t.1.width
		       f.hanger
		       t.0.imD t.1.print f.print
		     ;                      {
              char *temp;
      	      temp = @t.imD@.im+(@t.imD@.w*@t.0.line@)+@t.0.column@;
	      *(temp+@t.0.hanger@) = 't';
	      temp += @t.imD@.w;
	      *(temp+(@t.0.hanger@+@t.1.hanger@)/2) = '/';  						
	      *(temp+@t.0.hanger@) = '|';
	      *(temp+(@t.0.hanger@+@t.1.width@+3+@f.hanger@)/2) = '\\';
	      *(temp+@t.imD@.w+@t.0.hanger@) = '*';
			 }
	      @i @f.imD@ = @t.0.imD@;
	      @i @t.1.imD@ = @t.0.imD@;
        @}

	| 	f	{} 	
	 @{ @i @t.height@ = @f.height@ + 2;
	    @i @t.width@ = @f.width@;
	    @i @t.hanger@ = @f.hanger@;
	    @i @f.line@ = @t.line@ + 2;
	    @i @f.column@ = @t.column@;
            @i @t.val@ = @f.val@;
	    @e t.print: t.line t.column t.hanger f.print
		     t.imD
		   ;   {
              char *temp;
	      temp = @t.imD@.im+(@t.imD@.w*@t.line@)+@t.column@+@t.hanger@;
	      *temp = 't';
	      *(temp+@t.imD@.w) = '|';
			  }
	    @i @f.imD@ = @t.imD@;
         @}
	;

f	:	'('	e	')' 	{}
         @{ @i @f.height@ = @e.height@ + 2;
	    @i @f.width@ = 1 + @e.width@ + 1;
	    @i @f.hanger@ = @e.hanger@ + 1;
	    @i @e.line@ = @f.line@ + 2;
            @i @e.column@ = @f.column@ + 1;
            @i @f.val@ = @e.val@;
            @e f.print: f.line f.column f.hanger f.width
		     e.line e.column e.hanger e.width
                     f.imD e.print
		   ;   {
              char *temp;
              temp = @f.imD@.im+(@f.imD@.w*@f.line@)+@f.column@+@f.hanger@;
              *temp = 'f';
              temp += @f.imD@.w;
              *temp = '|';
              *(temp-2) = '/';
              *(temp+2) = '\\';
              temp += @f.imD@.w;
              *(temp-3) = '(';
              *(temp+3) = ')';
			   }
	    @i @e.imD@ = @f.imD@;
	 @}

	|	CONST  	{}
	 @{ @i @f.height@ = 3;
	    @i @f.width@ = 7;
	    @i @f.hanger@ = 3;
            @i @f.val@ = @CONST.val@;
	    @e f.print : f.line f.column f.hanger f.imD ;
                         {
              char *temp;
	      temp = @f.imD@.im+(@f.imD@.w*@f.line@)+@f.column@+@f.hanger@;
              *temp = 'f';
              *(temp+@f.imD@.w) = '|';
              strncpy(temp+(2*@f.imD@.w)-2,"CONST",5);
			 }
	 @}
	;
%%

#if YYBTYACC && !YYBYACC
void yyerror(const char *s, ...)
{extern int yylineno;
 fprintf(stderr,"Near line %d: %s\n",yylineno,s);
 yyyabort();
}
#else
void yyerror(const char *s)
{fprintf(stderr,"%s\n",s);
 yyyabort();
}
#endif

void showPT(imageDesc image)
  {int i;
   for (i=0;i<(image.w * image.h);i++) fputc((image.im)[i],stderr);
   free(image.im);
  }


int yyparse(void);

int main(int argc, char *argv[])
  {int quiet = 0;
   if ((argc > 1) && (argv[1][1] == 'q')) quiet = 1;
   yyparse();
  }
