
%{
#include <stdio.h>
#include "externf"
#include "typedef"
#include "parser.h"
%}
cha		[$a-zA-Z]
digit		[0-9]
spec		[_,-]
ch		({cha}|{digit}|{spec})
all		({cha}|{digit}|{spec}|[ ])
strn 		{cha}{ch}*
file_path	([/]{strn})+
opt		[wls]
	int		c;




%%
\{		{
			yylval.itemptr= install(yytext);
			return(LFBCTKN);
		}

\}		{
			yylval.itemptr=install(yytext);
			return(RTBCTKN);
		}

\(		{
			yylval.itemptr=install(yytext);
			return(LFPARNTKN);
		}

\)		{
			yylval.itemptr=install(yytext);
			return(RTPARNTKN);
		}

\+		{
			yylval.itemptr=install(yytext);
			return(PLUSTKN);
		}

\-		{
			yylval.itemptr=install(yytext);
			return(MINUSTKN);
		}

\*		{
			yylval.itemptr=install(yytext);
			return(MULTTKN);
		}

\/		{
			yylval.itemptr=install(yytext);
			return(DIVTKN);
		}

">="		{
			yylval.itemptr=install(yytext);
			return(COMPTKN);
		}

"<="		{
			yylval.itemptr=install(yytext);
			return(COMPTKN);
		}

">"		{
			yylval.itemptr=install(yytext);
			return(COMPTKN);
		}

"<"		{
			yylval.itemptr=install(yytext);
			return(COMPTKN);
		}

=		{
			yylval.itemptr= install(yytext);
			return(COMPTKN);
		}

!=		{
			yylval.itemptr= install(yytext);
			return(COMPTKN);
		}

"[="		{ 	yylval.itemptr= install(yytext);
			return(COMPTKN);
		}

"]="		{
			yylval.itemptr= install(yytext);
			return(COMPTKN);
		}

\]		{
			yylval.itemptr= install(yytext);
			return(RTSQBKTKN);
		}

\[		{
			yylval.itemptr= install(yytext);
			return(LFSQBKTKN);
		}

\:		{
			yylval.itemptr= install(yytext);
			return(SEMICTKN);
		}

:=		{
			yylval.itemptr=install(yytext);
			return(EQTKN);
		}

\,              {
			yylval.itemptr=install(yytext);
			return(COMMATKN);
		}

tdomrel         {
			yylval.itemptr=install(yytext);
			return(TDOMRELTKN);
		}

tdomatr         {
			yylval.itemptr=install(yytext);
			return(TDOMATRTKN);
		}

tdomc         {
			yylval.itemptr=install(yytext);
			return(TDOMCTKN);
		}

create		{
			yylval.itemptr=install(yytext);
			return(CREATKN);
		}

destroy		{
			yylval.itemptr=install(yytext);
			return(DESTRTKN);
		}

copy		{
			yylval.itemptr=install(yytext);
			return(COPYTKN);
		}

update		{
			yylval.itemptr=install(yytext);
			return(UPDATETKN);
		}

delete		{
			yylval.itemptr=install(yytext);
			return(DELETETKN);
		}

scheme		{
			yylval.itemptr=install(yytext);
			return(SCHEMETKN);
		}

print		{
			yylval.itemptr=install(yytext);
			return(PRINTTKN);
		}

rename		{
			yylval.itemptr=install(yytext);
			return(RENAMETKN);
		}

help		{
			yylval.itemptr=install(yytext);
			return(HELPTKN);
		}

append		{
			yylval.itemptr=install(yytext);
			return(APPENDTKN);
		}

from		{	yylval.itemptr=install(yytext);
			return(DIRTKN);
		}

into		{
			yylval.itemptr=install(yytext);
			return(DIRTKN);
		}

and		{
			yylval.itemptr=install(yytext);
			return(ANDTKN);
		}

or		{
			yylval.itemptr=install(yytext);
			return(ORTKN);
		}

where		{
			yylval.itemptr=install(yytext);
			return(WHERETKN);
		}

restrictedto    {
			yylval.itemptr=install(yytext);
			return(RESTRICTKN);
		}

on		{
			yylval.itemptr=install(yytext);
			return(ONTKN);
		}

union		{
			yylval.itemptr=install(yytext);
			return(UNIONTKN);
		}

diff		{
			yylval.itemptr=install(yytext);
			return(DIFFTKN);
		}

makerel		{
			yylval.itemptr=install(yytext);
			return(MAKERELTKN);
        	}

cprod		{       yylval.itemptr=install(yytext);
			return(CPRODTKN);
		}

select          {	yylval.itemptr=install(yytext);
			return(SELECTTKN);
		}	

project		{
			yylval.itemptr=install(yytext);
			return(PROJTKN);
		}

njoin		{
			yylval.itemptr=install(yytext);
			return(NJOINTKN);
		}

dirjoin         {
			yylval.itemptr=install(yytext);
			return(DIRJOINTKN);
                }

equijoin	{
			yylval.itemptr=install(yytext);
			return(EQUIJOINTKN);
		}

compute		{
			yylval.itemptr=install(yytext);
			return(COMPUTETKN);
		}

unpack		{
			yylval.itemptr=install(yytext);
			return(UNPACKTKN);
		}

setf		{
			yylval.itemptr=install(yytext);
			return(SETFTKN);
		}

pack		{
			yylval.itemptr=install(yytext);
			return(PACKTKN);
		}

aggrf		{
			yylval.itemptr=install(yytext);
			return(AGGRFTKN);
		}

abt		{
			yylval.itemptr=install(yytext);
			return(ABTTKN);
		}

createdb	{
			yylval.itemptr=install(yytext);
			return(CRDBTKN);
		}

deletedb	{
			yylval.itemptr=install(yytext);
			return(DELDBTKN);
		}
edit            {
			yylval.itemptr=install(yytext);
			return(EDTKN);
		}
read		{
			yylval.itemptr=install(yytext);
			return(READTKN);
		}

key[ ]*= 	{
			yylval.itemptr=install(yytext);
			return(KEYTKN);
		}

org[ ]*=	{
			yylval.itemptr=install(yytext);
			return(ORGTKN);
		}

[ \t,]		;

[-]{opt}	{
			yylval.itemptr=install(yytext);
			return(OPTTKN);
		}

{file_path}	{
			yylval.itemptr=install(yytext);
			return(PATHTKN);
		}

{strn}		{
			yylval.itemptr=install(yytext);
			return(VARTKN);
		}

[-]*{digit}*[.]*{digit}* {
			yylval.itemptr=install(yytext);
			return(VARNOTKN);
		}

["]{all}*["]	{
			getstr(yytext);
			yylval.itemptr=install(yytext);
			return(STRTKN);
		}

[\n]		{
			unput(0);
			return(GOTKN);
		}

%%

int yywrap(void)
{
	return(( c == EOF) ? 0: 1);
}
