%{
#if defined (__cplusplus)
#include <cstdio>
#include <cstring>
#else /* !defined (__cplusplus) */
#include <stdio.h>
#if defined (__sun) && defined (__SVR4)
#include <strings.h>
#else
#include <string.h>
#endif
#endif /* !defined (__cplusplus) */

#include "externf"
#include "typedef"

#if YYBTYACC && !YYBYACC
/* the `btyacc' 3.0 skeleton omits the following */
#include "parser.h"
#endif

struct node *left, *right, *root;
struct item *head;
char *errmsg;

struct node *newnode(int,char *,struct node *,struct node *);

extern int yylex(void);

#if YYBTYACC && !YYBYACC
void yyerror(const char *, ...);
#else
void yyerror(const char *);
#endif
%}

%union {
		struct item	*itemptr;
		struct node	*ndptr;
	}

%start command
%token  <itemptr>       COMMATKN RESTRICTKN TDOMRELTKN TDOMATRTKN TDOMCTKN LFSQBKTKN RTSQBKTKN
%token	<itemptr>	CREATKN VARTKN VARNOTKN LFPARNTKN RTPARNTKN EQTKN GOTKN LFBCTKN RTBCTKN COMPUTETKN SEMICTKN
%token 	<itemptr>	DESTRTKN COPYTKN DIRTKN PATHTKN OPTTKN KEYTKN ORGTKN UPDATETKN WHERETKN STRTKN MAKERELTKN
%token	<itemptr>	PLUSTKN MINUSTKN MULTTKN DIVTKN COMPTKN ANDTKN ORTKN DELETETKN UNIONTKN DIFFTKN CPRODTKN
%token  <itemptr>	SELECTTKN PROJTKN SCHEMETKN ONTKN PRINTTKN UNPACKTKN SETFTKN PACKTKN NJOINTKN HELPTKN
%token  <itemptr>	ABTTKN AGGRFTKN CRDBTKN DELDBTKN RENAMETKN APPENDTKN EDTKN READTKN EQUIJOINTKN DIRJOINTKN
%type	<ndptr>		domain_list varno_list var_list from_list opt_list key_list org_list str_list arith_exp tuple_list
%type   <ndptr>		atr_ass_list atr_ass cond_exp cond_exp_list str_set varno_set algeb_exp set_list command_name command_list
%type   <ndptr>		temporal_ass temporal_element_ass temporal_element temporal_int temporal_exp_list temporal_exp
%left UNIONTKN DIFFTKN NJOINTKN CPRODTKN EQUIJOINTKN DIRJOINTKN
%left PLUSTKN MINUSTKN
%left MULTTKN DIVTKN
%left ANDTKN  ORTKN


%%
command		: CREATKN VARTKN LFPARNTKN domain_list  RTPARNTKN key_list org_list   GOTKN
		{
			left= newnode(VAR,$2->namep,NULL,NULL);
			left= newnode(LINK,(char *)"link",left,$7);
			right = newnode(LINK,(char *)"link",$4,$6);
			root= newnode(CREATE,$1->namep,left,right);
		}
		| COPYTKN opt_list VARTKN LFPARNTKN var_list RTPARNTKN DIRTKN PATHTKN GOTKN
		{
			right=newnode(DIR,$7->namep,NULL,NULL);
			left=newnode(LINK,(char *)"link",$2,right);
			right=newnode(FIL,$8->namep,NULL,NULL);
			left=newnode(LINK,(char *)"link",left,right);
			right=newnode(LINK,(char *)"link",left,$5);
			left=newnode(REL,$3->namep,NULL,NULL);
			root=newnode(COPY,$1->namep,left,right);
		}
		| APPENDTKN VARTKN tuple_list GOTKN
		{
			left=newnode(VAR,$2->namep,NULL,NULL);
			root=newnode(APPEND,(char *)"append",left,$3);
		}
		| UPDATETKN VARTKN LFPARNTKN atr_ass_list RTPARNTKN WHERETKN cond_exp_list GOTKN
		{
			left=newnode(REL,$2->namep,NULL,NULL);
			left=newnode(LINK,(char *)"link",left,$4);
			root=newnode(UPDATE,(char *)"update",left,$7);
		}
		| DELETETKN VARTKN WHERETKN cond_exp_list GOTKN
		{
			left=newnode(REL,$2->namep,NULL,NULL);
			root=newnode(DELETE,(char *)"delete",left,$4);
		}
		| DESTRTKN var_list GOTKN
		{
			root=newnode(DESTROY,$1->namep,$2,NULL);

		}
		| SCHEMETKN opt_list var_list GOTKN
		{
			root=newnode(SCHEME,(char *)"scheme",$3,$2);
		}
		| HELPTKN opt_list command_list GOTKN
		{
			root=newnode(HELP,(char *)"help",$3,$2);
		}
		| algeb_exp GOTKN
		{
			if($1->ndtype==REL)
			{
				if(strcmp($1->namep,"q")==0)
					$1->ndtype=QUIT;
				else
					fprintf(stderr,"SYNTAX ERROR: %s\n",$1->namep);
				root=$1;
			}
			else
			{
				left=newnode(PRINT,(char *)"print",$1,NULL);
				root=newnode(ALGEB,(char *)"algeb",left,NULL);
			}
		}
		| VARTKN EQTKN 	algeb_exp GOTKN
		{
			right=newnode(REL,$1->namep,NULL,NULL);
			left=newnode(EQ,$2->namep,$3,right);
			root=newnode(ALGEB,(char *)"algeb",left,NULL);
		}
		| PRINTTKN opt_list algeb_exp GOTKN
		{
			left=newnode(PRINT,(char *)"print",$3,$2);
			root=newnode(ALGEB,(char *)"algeb",left,NULL);
		}
		| RENAMETKN VARTKN LFPARNTKN domain_list RTPARNTKN GOTKN
		{	
			left=newnode(REL,$2->namep,NULL,NULL);
			root=newnode(RENAME,$1->namep,left,$4);
		}
		|
		GOTKN
		{
		}
		| error GOTKN
		{
			fprintf(stderr,"SYNTAX ERROR: %s",errmsg);
			root=newnode(ERROR,(char *)"",NULL,NULL);
		}
		;
domain_list	:
		{
			$$=NULL;
		}
	     	|  domain_list VARTKN EQTKN VARTKN
		{
			left= newnode(FORMAT,$4->namep,NULL,NULL);
			right= newnode(ATR,$2->namep,left,NULL);	
			$$=newnode(LINK,(char *)"link",$1,right);
		}
		;
varno_list	:
		{
			$$=NULL;
		}
		| VARNOTKN
		{
			$$=newnode(VARNO,$1->namep,NULL,NULL);
		}
		| VARNOTKN SEMICTKN VARNOTKN
		{
			left=newnode(VARNO,$1->namep,NULL,NULL);
			right=newnode(VARNO,$3->namep,NULL,NULL);
			$$=newnode(NRANGE,(char *)"",left,right);
		}
		| varno_list VARNOTKN
		{
		        right=newnode(VARNO,$2->namep,NULL,NULL);
			$$=newnode(LINK,(char *)"link",$1,right);
		}
		;
command_name	: CRDBTKN
		{
			$$=newnode(CREATEDB,$1->namep,NULL,NULL);
		}
		| DELDBTKN
		{
			$$=newnode(DELETEDB,$1->namep,NULL,NULL);
		}
		| DESTRTKN
		{
			$$=newnode(DESTROY,$1->namep,NULL,NULL);
		}
		| CREATKN
		{
			$$=newnode(CREATE,$1->namep,NULL,NULL);
		}
		| COPYTKN
		{
			$$=newnode(COPY,$1->namep,NULL,NULL);
		}
		| UPDATETKN
		{
			$$=newnode(UPDATE,$1->namep,NULL,NULL);
		}
		| DELETETKN
		{
			$$=newnode(DELETE,$1->namep,NULL,NULL);
		}
		| NJOINTKN
		{
			$$=newnode(NJOIN,$1->namep,NULL,NULL);
		}
		| DIRJOINTKN
		{
			$$=newnode(DIRJOIN,$1->namep,NULL,NULL);
		}
		| EQUIJOINTKN
		{
			$$=newnode(EQUIJOIN,$1->namep,NULL,NULL);
		}
		| UNIONTKN
		{
			$$=newnode(UNION,$1->namep,NULL,NULL);
		}
		| DIFFTKN
		{
			$$=newnode(DIFF,$1->namep,NULL,NULL);
		}
		| CPRODTKN
		{
			$$=newnode(CPROD,$1->namep,NULL,NULL);
		}
		| SELECTTKN
		{
			$$=newnode(SELECT,$1->namep,NULL,NULL);
		}
		| PROJTKN
		{
			$$=newnode(PROJECT,$1->namep,NULL,NULL);
		}
		| SETFTKN
		{
			$$=newnode(SETF,$1->namep,NULL,NULL);
		}
		| COMPUTETKN
		{
			$$=newnode(COMPUTE,$1->namep,NULL,NULL);
		}
		| PACKTKN
		{
			$$=newnode(PACK,$1->namep,NULL,NULL);
		}
		| UNPACKTKN
		{
			$$=newnode(UNPACK,$1->namep,NULL,NULL);
		}
		| AGGRFTKN
		{
			$$=newnode(AGGRF,$1->namep,NULL,NULL);
		}
		| ABTTKN
		{
			$$=newnode(ABT,$1->namep,NULL,NULL);
		}
		| SCHEMETKN
		{
			$$=newnode(SCHEME,$1->namep,NULL,NULL);
		}
		| PRINTTKN
		{
			$$=newnode(PRINT,$1->namep,NULL,NULL);
		}
		| RENAMETKN
		{
			$$=newnode(RENAME,$1->namep,NULL,NULL);
		}
		| APPENDTKN
		{
			$$=newnode(APPEND,$1->namep,NULL,NULL);
		}
		| HELPTKN
		{
			$$=newnode(HELP,$1->namep,NULL,NULL);
		}
		| VARTKN
		{
			$$=newnode(VAR,$1->namep,NULL,NULL);
		}
		;
command_list	:
		{
			$$=NULL;
		}
		| command_list command_name
		{
			$$=newnode(LINK,(char *)"",$1,$2);
		}
		;
var_list	:
		{
			$$=NULL;
		}
		| var_list VARTKN
		{
			right=newnode(VAR,$2->namep,NULL,NULL);
			$$=newnode(LINK,(char *)"link",$1,right);
		}
		;
from_list	:VARTKN
		{
			$$ = newnode(REL,$1->namep,NULL,NULL);
		}
		| from_list VARTKN
		{
			right = newnode(REL,$2->namep,NULL,NULL);
			$$ = newnode(CPROD,(char *)"cproduct",$1,right);
		}
		;
opt_list	:
		{
			$$=NULL;
		}
		| opt_list OPTTKN
		{
			right=newnode(OPT,$2->namep,NULL,NULL);
			$$=newnode(LINK,(char *)"",$1,right);
		}
		;
key_list	:
		{
			$$=NULL;
		}
		| KEYTKN varno_list
		{
			$$= $2;
		}
		;
org_list	:
		{
			$$=NULL;
		}
		| ORGTKN VARNOTKN
		{
			$$= newnode(ORG,$2->namep,NULL,NULL);
		}
		;
str_list	: STRTKN
		{
			$$=newnode(STR,$1->namep,NULL,NULL);
		}
		| STRTKN SEMICTKN STRTKN
		{
			left=newnode(STR,$1->namep,NULL,NULL);
			right=newnode(STR,$3->namep,NULL,NULL);
			$$=newnode(CRANGE,(char *)"",left,right);
		}
		| str_list STRTKN
		{
			right=newnode(STR,$2->namep,NULL,NULL);
			$$=newnode(LINK,(char *)"link",$1,right);
		}
		;
varno_set	: LFBCTKN varno_list RTBCTKN
		{
			if($2 != NULL)
				$$=newnode(SET,(char *)"d",$2,NULL);
			else
				$$=newnode(SET,(char *)"",NULL,NULL);
		}
		;
str_set		: LFBCTKN str_list RTBCTKN
		{
			$$=newnode(SET,(char *)"c",$2,NULL);
		}
		;
set_list	: str_set
		{
			$$=$1;
		}
		| varno_set
		{
			$$=$1;
		}
		| set_list str_set
		{
			$$=newnode(LINK,(char *)"link",$1,$2);
		}
		| set_list varno_set
		{
			$$=newnode(LINK,(char *)"link",$1,$2);
		}
	        ;

arith_exp	: VARNOTKN
		{
			$$=newnode(VARNO,$1->namep,NULL,NULL);
		}
		| VARTKN
		{
			$$=newnode(VAR,$1->namep,NULL,NULL);
		}
		| MINUSTKN arith_exp %prec MULTTKN
		{
			$$=newnode(MINUS,(char *)"-",NULL,$2);
		}
		| LFPARNTKN arith_exp RTPARNTKN
		{
			$$=$2;
		}
		| arith_exp MINUSTKN arith_exp
		{
			$$=newnode(MINUS,(char *)"-",$1,$3);
		}
		| arith_exp PLUSTKN arith_exp
		{
			$$=newnode(PLUS,(char *)"+",$1,$3);
		}
		| arith_exp MULTTKN arith_exp
		{
			$$=newnode(MULT,(char *)"*",$1,$3);
		}
		| arith_exp DIVTKN arith_exp
		{
			$$=newnode(DIV,(char *)"/",$1,$3);
		}
		;
atr_ass_list	: atr_ass
		{
			$$=$1;
		}
		| atr_ass_list atr_ass
		{
			$$=newnode(LINK,(char *)"link",$1,$2);
		}
		;
tuple_list	: LFPARNTKN atr_ass_list RTPARNTKN
		{
			$$=newnode(TUPLE,(char *)"tuple",$2,NULL);
		}
		| tuple_list LFPARNTKN atr_ass_list RTPARNTKN
		{
			right=newnode(TUPLE,(char *)"tuple",$3,NULL);
			$$=newnode(LINK,(char *)"link",$1,right);
		}
		;
atr_ass         : VARTKN EQTKN temporal_ass
		{
		   left = newnode(VAR,$1->namep,NULL,NULL);
		   $$ = newnode(EQ,$2->namep,left,$3);
                }
		| VARTKN EQTKN str_set
		{
			left=newnode(VAR,$1->namep,NULL,NULL);
			$$=newnode(EQ,$2->namep,left,$3);
		}
		|VARTKN EQTKN STRTKN
		{
			left=newnode(VAR,$1->namep,NULL,NULL);
			right=newnode(STR,$3->namep,NULL,NULL);
			$$=newnode(EQ,$2->namep,left,right);
		}
		|VARTKN EQTKN varno_set
		{	left=newnode(VAR,$1->namep,NULL,NULL);
			$$=newnode(EQ,$2->namep,left,$3);
		}
		|VARTKN EQTKN arith_exp
		{
			left=newnode(VAR,$1->namep,NULL,NULL);
			$$=newnode(EQ,$2->namep,left,$3);
		}
		;
temporal_ass    : temporal_element_ass
		{
		  $$ = $1;
                }
		| temporal_ass temporal_element_ass
		{
		  $$ = newnode(LINK,(char *)"link",$1,$2);
                }
		;
temporal_element_ass
		: temporal_element STRTKN
		{
		  right = newnode(STR,$2->namep,NULL,NULL);
		  $$ = newnode(TEMPELASS,(char *)"c",$1,right);
                }
		| temporal_element VARNOTKN
		{
		  right = newnode(VARNO,$2->namep,NULL,NULL);
		  $$ = newnode(TEMPELASS,(char *)"d",$1,right);
                }
		;
temporal_element : temporal_int
		{
		  $$ = $1;
                }
		| temporal_element PLUSTKN temporal_int
		{
		  $$ = newnode(LINK,(char *)"link",$1,$3);
                }
		;
temporal_int    : LFSQBKTKN VARNOTKN COMMATKN VARNOTKN RTSQBKTKN
		{
		  left = newnode(VARNO,$2->namep,NULL,NULL);
		  right = newnode(VARNO,$4->namep,NULL,NULL);
		  $$ = newnode(TEMPINT,(char *)"tempint",left,right);
                }
		;
cond_exp	: VARTKN COMPTKN varno_set
		{
			left=newnode(VAR,$1->namep,NULL,NULL);
			$$=newnode(COMP,$2->namep,left,$3);
		}
		| VARTKN COMPTKN STRTKN
		{
			left=newnode(VAR,$1->namep,NULL,NULL);
			right=newnode(STR,$3->namep,NULL,NULL);
			$$=newnode(COMP,$2->namep,left,right);
		}
		| VARTKN COMPTKN arith_exp
		{
			left=newnode(VAR,$1->namep,NULL,NULL);
			$$= newnode(COMP,$2->namep,left,$3);
		}
		| VARTKN COMPTKN str_set
		{
			left=newnode(VAR,$1->namep,NULL,NULL);
			$$=newnode(COMP,$2->namep,left,$3);
		}
		| temporal_exp_list COMPTKN temporal_exp_list
		{
		 	$$ = newnode(COMP,$2->namep,$1,$3);
                }
		| temporal_exp_list LFSQBKTKN temporal_exp_list
		{
		 	$$ = newnode(COMP,$2->namep,$1,$3);
                }
		| temporal_exp_list RTSQBKTKN temporal_exp_list
		{
		 	$$ = newnode(COMP,$2->namep,$1,$3);
                }
		;
cond_exp_list	: cond_exp
		{
			$$=$1;
		}
		| cond_exp_list ANDTKN cond_exp_list
		{
			$$= newnode(AND,(char *)"and",$1,$3);
		}
		| cond_exp_list ORTKN cond_exp_list
		{
			$$=newnode(OR,(char *)"or",$1,$3);
		}
		| LFPARNTKN cond_exp_list RTPARNTKN
		{
			$$=$2;
		}
		;
temporal_exp    : temporal_int
		{
			$$ = $1;
                }
		| TDOMRELTKN LFPARNTKN VARTKN RTPARNTKN
		{
			left = newnode(REL,$3->namep,NULL,NULL);
			$$ = newnode(TDOMREL,(char *)"tdomrel",left,NULL);
                }
		| TDOMATRTKN LFPARNTKN VARTKN RTPARNTKN
		{
			left = newnode(VAR,$3->namep,NULL,NULL);
			$$ = newnode(TDOMATR,(char *)"tdoma",left,NULL);
                }
		| TDOMCTKN LFPARNTKN cond_exp RTPARNTKN
		{
			$$ = newnode(TDOMC,(char *)"tdomc",$3,NULL);
                }
		;
temporal_exp_list
		: temporal_exp
		{
		  $$ = $1;
                }
		| temporal_exp_list MULTTKN temporal_exp_list
		{
		  $$ = newnode(TEMPINTERSECT,(char *)"tempintersect",$1,$3);
                }
		| temporal_exp_list PLUSTKN temporal_exp_list
		{
		  $$ = newnode(TEMPUNION,(char *)"tempunion",$1,$3);
                }
		| temporal_exp_list MINUSTKN temporal_exp_list
		{
		  $$ = newnode(TEMPDIFF,(char *)"tempdiff",$1,$3);
                }
		| LFPARNTKN temporal_exp_list RTPARNTKN
		{
		  $$ = $2;
                }
		;
algeb_exp	: VARTKN
		{
			$$=newnode(REL,$1->namep,NULL,NULL);
		}
		| MAKERELTKN LFPARNTKN VARTKN EQTKN set_list RTPARNTKN
		{
			$$=newnode(MAKEREL,$3->namep,$5,NULL);
		}
		| LFPARNTKN algeb_exp RTPARNTKN
		{
			$$=$2;
		}
		| algeb_exp CPRODTKN algeb_exp
		{
			$$=newnode(CPROD,$2->namep,$1,$3);
		}
		| SELECTTKN var_list DIRTKN from_list
		{
			right=newnode(LINK,(char *)"link",$2,NULL);
			left = newnode(LINK,(char *)"link",$4,NULL);
			$$=newnode(SELECT,$1->namep,left,right);
		}
		| SELECTTKN var_list DIRTKN from_list WHERETKN cond_exp_list
		{
			right=newnode(LINK,(char *)"link",$2,$6);
			left = newnode(LINK,(char *)"link",$4,NULL);
			$$=newnode(SELECT,$1->namep,left,right);
		}
		| SELECTTKN var_list DIRTKN from_list RESTRICTKN temporal_exp_list
         	{
			right=newnode(LINK,(char *)"link",$2,NULL);
			left = newnode(LINK,(char *)"link",$4,$6);
			$$=newnode(SELECT,$1->namep,left,right);
		}
		| SELECTTKN var_list DIRTKN from_list WHERETKN cond_exp_list RESTRICTKN temporal_exp_list
         	{
			right=newnode(LINK,(char *)"link",$2,$6);
			left = newnode(LINK,(char *)"link",$4,$8);
			$$=newnode(SELECT,$1->namep,left,right);
		}
		| COMPUTETKN algeb_exp LFPARNTKN arith_exp RTPARNTKN
		{
			$$=newnode(COMPUTE,(char *)"",$2,$4);
		}
		;
%%
#include <stdlib.h>
#include <stdio.h>

char *strsave(char *);

/******************************************************************************
*	Insert an item into a list. The pointer to this item will be returned *
******************************************************************************/
struct item 	*install(char *s)
{	

	struct item	*p;

	p=(struct item *) calloc (1,sizeof(struct item));
	if(p!=NULL)
	{
		p->namep= strsave(s);
		p->next = head;
		head    = p;
	}
	return(p);
}

/******************************************************************************
*	Create a new node,and pointer to this node is returned.               *
******************************************************************************/
struct node	*newnode(int type, char *nmp, struct node *lfp, struct node *rtp)
{
        char  *cp;
	struct node	*np;

	np= (struct node *) calloc (1,sizeof (struct node));
	if((cp = (char *) calloc((strlen(nmp)+2), sizeof(char))) == NULL) {
	       fprintf(stderr,"newnode: no memory available\n");
	       exit(0);
        }
	np->ndtype= type;
	strcpy(cp, nmp);
	np->namep = cp;
	np->lf	  = lfp;
	np->rt	  = rtp;
	return(np);
}

/******************************************************************************
*	Print syntax error message.                                           *
******************************************************************************/
#if YYBTYACC && !YYBYACC
void yyerror(const char *s, ...)
#else
void yyerror(const char *s)
#endif
{


	if(head)
		strcpy(errmsg,head->namep);

}

void getstr(char *s)
{
	char 	*sptr,*data;
	int	flag=0;



	data=sptr=s;
	for(sptr++;*sptr !='\"';sptr++)
	{
		if(*sptr==' ' )
		{
			if(flag==0)
			{
				*data++ = *sptr;
				flag=1;
			}
		}
		else
		{
			flag=0;
			*data++ = *sptr;
		}
	}
	*data= '\0';
}

char *strsave(char *s)

{
	char  *p;
	
	if((p= (char *) calloc (1,(strlen(s)+1))) != NULL)
	    strcpy(p, s);
	return(p);
}	


int yyparse(void);

int main(int argc, char *argv[])
  {int quiet = 0;
   if ((argc > 1) && (argv[1][1] == 'q')) quiet = 1;
   yyparse();
  }
