/* Y-file for translation of infix expressions to prefix and postfix */
%token ID CONST  
%start s    
%left '+' '-'
%left '*' '/'

@attributes {char *lexeme;} ID CONST 
@traversal @preorder LRpre
@traversal LRpost

%{ 
#include <stdio.h>

#if YYBTYACC && !YYBYACC
/* the `btyacc' 3.0 skeleton omits the following */
#include "parser.h"
#endif

extern int yylex(void);

#if YYBTYACC && !YYBYACC
void yyerror(const char *, ...);
#else
void yyerror(const char *);
#endif
%} 

%%
s       :       expr
                @{ @LRpost fprintf(stderr,"\n"); 
                   @LRpost @revorder (((2<1)?(abs(-1)):abs(22-23)))
                   /* an expression with nested parentheses
                      works as a traversal modifier expression */ fprintf(stderr,"postfix:  ");
                   @LRpre  @revorder (1) fprintf(stderr,"\n"); 
                   @LRpre  fprintf(stderr,"prefix:   ");
                @}
        ;
expr    :       expr    '*'     expr
                @{ @LRpost fprintf(stderr," * "); 
                   @LRpre  fprintf(stderr," * "); 
                @}
        |       expr    '+'     expr
                @{ @LRpre  fprintf(stderr," + "); 
                   @LRpost fprintf(stderr," + "); 
                @}
        |       expr    '/'     expr
                @{ @LRpost fprintf(stderr," / "); 
                   @LRpre  fprintf(stderr," / "); 
                @}
        |       expr    '-'     expr
                @{ @LRpost fprintf(stderr," - "); 
                   @LRpre  fprintf(stderr," - "); 
                @}
        |       '('     expr    ')'
        |       ID
                @{ @LRpost fprintf(stderr," %s ",@ID.lexeme@); 
                   @LRpre /* nested compound statements
                             work within traversal actions */
                          {{if (true) {fputc(' ',stderr);
                                       if (true)
                                         {fprintf(stderr,"%s",@ID.lexeme@);
                                          if (true) {fputc(' ',stderr);}}}}}
                @}
        |       CONST
                @{ @LRpost fprintf(stderr," %s ",@CONST.lexeme@); 
                   @LRpre  fprintf(stderr," %s ",@CONST.lexeme@); 
                @}
        ;
%% 
#if YYBTYACC && !YYBYACC
void yyerror(const char *s, ...)
{extern int yylineno;
 fprintf(stderr,"Near line %d: %s\n",yylineno,s); 
 yyyabort(); 
}  
#else  
void yyerror(const char *s)
{fprintf(stderr,"%s\n",s);
 yyyabort(); 
}
#endif

int yyparse(void);

int main() 
  {yyparse(); 
  } 



