/*  a simple expression grammar. */ 

%token CONST  
%start s   

%{
#include <stdio.h>

#if YYBTYACC && !YYBYACC
/* the `btyacc' 3.0 skeleton omits the following */
#include "parser.h"
#endif

extern int yylex(void);

#if YYBTYACC && !YYBYACC
void yyerror(const char *, ...);
#else
void yyerror(const char *);
#endif
%}

%%
s	: 	e  	
	; 

e	:	e 	'+'	t	 	
	|	t			 
	;

t	:	t	'*'	f	
	| 	f			 
	;

f	:	'('	e	')' 	
	|	CONST   		 
	;
%% 
#if YYBTYACC && !YYBYACC
void yyerror(const char *s, ...)
{extern int yylineno;
 fprintf(stderr,"Near line %d: %s\n",yylineno,s); 
 yyyabort(); 
}  
#else  
void yyerror(const char *s)
{fprintf(stderr,"%s\n",s);
 yyyabort(); 
}
#endif

int yyparse(void);

int main() 
  {yyparse(); 
  } 

